/*
 * SalomeTMF is a Test Management Framework
 * Copyright (C) 2007 EDF / France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * @author Jrmie DEFAYE
 *
 * Contact: mikael.marche@rd.francetelecom.com
 */
package salomeTMF_plug.ExtractAttachments;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.HeadlessException;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Properties;
import java.util.StringTokenizer;

import javax.crypto.spec.SecretKeySpec;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;

import org.objectweb.salome_tmf.data.Project;
import org.objectweb.salome_tmf.ihm.main.SalomeTMFContext;
import org.objectweb.salome_tmf.ihm.main.datawrapper.DataModel;
import org.objectweb.salome_tmf.ihm.tools.Tools;
import org.objectweb.salome_tmf.plugins.IPlugObject;
import org.objectweb.salome_tmf.data.AdminProjectData;

import salomeTMF_plug.ExtractAttachments.language.Language;
import salomeTMF_plug.ExtractAttachments.sqlWrapper.SQLWrapper;
import salomeTMF_plug.ExtractAttachments.FenetreSaisieConfig;

import org.objectweb.salome_tmf.api.Api;
import org.objectweb.salome_tmf.api.Util;
import org.objectweb.salome_tmf.api.sql.IDataBase;
import org.objectweb.salome_tmf.api.sql.ISQLObjectFactory;

import com.enterprisedt.net.ftp.FTPClient;
import com.enterprisedt.net.ftp.FTPException;
import com.enterprisedt.net.ftp.FTPMessageCollector;
import com.enterprisedt.net.ftp.FTPTransferType;


/**
 * fonction qui dtache toutes les pices jointes de SalomTMF et 
 * insre les pices jointes des campagnes dans Mantis
 * @author Defaye Jrmie
 * @version 1.0
 */
public class DetachAttachment extends JDialog{

	/**
	 * Get the File Separator (different between Unix and Windows)
	 */
	private String fs = System.getProperties().getProperty("file.separator");
    /**
     * Variable d'interface Homme Machine
     */
	private IPlugObject pIhm = null;
    /**
     * Url de SalomeTMF
     */
	private URL urlBase;
    /**
     * Url de salomTMF au formaTexte
     */
	private String urlTexte;
    /**
     * Rpertoire de base
     */
	private String repertoireDeBase;
    /**
     * Rpertoire de stockage des pices jointes Mantis
     */
	private String repertoireStockageMantis;
    /**
     * Fichier de configuratino Mantis
     */
	private Properties  cfg_prop = null;
    /**
     * Rpertoire des pices jointes de Mantis
     */
	private String RepertoirePJMantis;

//	special mantis
	final String MANTIS_CFG_FILE_SALOME = "/plugins/mantis/cfg/CfgMantis.properties";
    /**
     * Mthode d'import Mantis
     */
	private String mantisImportMode;
    /**
     * Adresse Mantis
     */
	private String mantis_Host;
    /**
     * Driver ODBC Mantis
     */
	private String driver_Mantis;
    /**
     * URL Base de donnes Mantis
     */
	private String url_Db_Mantis;
    /**
     * Nom Utilsateur Mantis
     */
	private String user_Mantis;
    /**
     * Mot de passe compte Mantis
     */
	private String pwd_Mantis; 
    /**
     * URL Mantis
     */
	private String url_Http_Mantis;

    /**
     * Connecteur  la base de donnes Mantis
     */
	private IDataBase iDB = null;
    /**
     * Proprite du connecteur SQL
     */
	private Properties sql_Prop = null;
    /**
     * Numro d'identification du projet
     */
	private int projetID;
    /**
     * Prparateur de Requte SQL
     */
	private PreparedStatement prep;
    /**
     * Execution de Requte SQL
     */
	private ResultSet stmtRes;
    /**
     * Prparateur de Requte SQL
     */
	private PreparedStatement prep2;
    /**
     * Execution de Requte SQL
     */
	private ResultSet stmtRes2;
    /**
     * Compteur nombre de pices jointes dtaches de SalomTMF
     */
	private int nbPJDetaches=0;
    /**
     * Compteur nombre de pices jointes Insres dans Mantis
     */
	private int nbInsertionMantis=0;
    /**
     * Nom de la pice jointe
     */
	private String NomPJ;
    /**
     * numro d'identification de fiche Mantis
     */
	private String ID_Mantis2;
    /**
     * Variable de stockage de la pice jointe
     */
	private String location;
	/**
     * boolean de test de connexion Mantis
     */
	private boolean ConnexionMantisOK=false;

   /**
    * Arraylist :
    * format id_camp / nom_camp / Id_projet
    */
	private ArrayList<String> vecteurCampagneTest = new ArrayList<String>();
/**
    * Arraylist :
    *	format id_Exec / nom_exec / id_camp
 */
	private ArrayList<String> vecteurExecCampagne = new ArrayList<String>();
/**
    * Arraylist :
    * format id_Res_Exec / nom_Res_exec / id_Exec
 */
	private ArrayList<String> vecteurResExecCampagne = new ArrayList<String>();
/**
    * Arraylist :
    * format id_Exec_Cas / nom_Exec_Cas / id_Res_Exec
 */
	private ArrayList<String> vecteurExecCas = new ArrayList<String>();
/**
    * Arraylist :
    *	format id_attachment / Null / id_Exec_Cas
 */
	private ArrayList<String> vecteurAttachmentExecCas = new ArrayList<String>();
/**
    * Arraylist :
    *	format id_attachment / MantisAtach / id_Exec_Cas
 */
	private ArrayList<String> vecteurAttachmentMantisExecCas = new ArrayList<String>();

/**
    * Arraylist :
    *	format id_attachment / cheminDeStockage /nomFichier
 */
	private ArrayList<String> vecteurRequirement = new ArrayList<String>();

	private String repertoireStockage;
	private String nouvel_Url;

//	spcial boite dialogue
	private JLabel informationLabel;
	private JButton valider;
	private JButton annuler;
	private JButton parametres;
	private JProgressBar progress;
	private JLabel LieuStockage;
	private JCheckBox importMantis;
	private boolean selectionImportMantis;
	private JLabel erreurLabel;

//	Connexion FTP
	private String ftpSalomeServer;
	private String ftpSalomeUser;
	private String ftpSalomePassword;
	private String ftpSalomeDirectory;
	private FTPClient ftpSalome;
	private FTPMessageCollector listenerSalome;
	private Object salomeExportMode;
	private String salomeFTPSortie;
	private Project proj;
	private Timestamp sqlDate;			

//	Connexion FTP
	private String ftpMantisServer;
	private String ftpMantisUser;
	private String ftpMantisPassword;
	private String ftpMantisDirectory;
	private FTPClient ftpMantis;
	private FTPMessageCollector listenerMantis;

	private String cle = "melosajd";
	private String repFtpMantis;
	private String repFtpSalome;


	/**
	 * Fonction de dtachement des pices jointes
	 * @param vt IPlugObject
	 * @throws Exception
	 */
	public DetachAttachment(IPlugObject vt) throws Exception {
		super(SalomeTMFContext.getInstance().getSalomeFrame(), true);

		fs="/";
		pIhm = vt;
		urlBase = SalomeTMFContext.getInstance().getUrlBase();
		String _urlBase = urlBase.toString();
		urlTexte = _urlBase.substring(0, _urlBase.lastIndexOf("/"));
		proj = DataModel.getCurrentProject();
		
		//sqlDate = new java.sql.Date(System.currentTimeMillis());
		java.util.Date date = new java.util.Date();
		sqlDate = new java.sql.Timestamp(date.getTime());
		
		//Gestion de la progressbar
		progress = new JProgressBar();
		JPanel progression = new JPanel(new FlowLayout(FlowLayout.CENTER));
		progression.add(progress);

		//gestion des boutons
		valider = new JButton(Language.getInstance().getText("Valider"));
		valider.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				progress.setIndeterminate(true);
				Thread t = new Thread() {
					public void run() {
						// Instanciation et lancement du traitement
						try {
							progress.setIndeterminate(true);
							valider.setEnabled(false);
							annuler.setEnabled(false);
							parametres.setEnabled(false);
							importMantis.setEnabled(false);
							rundetachment();
						} catch (Exception ex) {
							Tools.ihmExceptionView(ex);
						}
					}
				};
				t.start();
			}
		});

		annuler = new JButton(Language.getInstance().getText("Annuler"));
		annuler.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				DetachAttachment.this.dispose();
			}
		});

		parametres = new JButton(Language.getInstance().getText("Parametres"));
		parametres.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					runConfigWindow();
				} catch (HeadlessException e1) {
					e1.printStackTrace();
				} catch (Exception e1) {
					e1.printStackTrace();
				}				
			}
		});

		importMantis = new JCheckBox(Language.getInstance().getText("ImportMantis"));
		importMantis.setSelected(true);
		selectionImportMantis = true;
		importMantis.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					if (!importMantis.isSelected()) {
						selectionImportMantis = false;
					} else {
						selectionImportMantis = true;
					}
				} catch (Exception ex) {
					Tools.ihmExceptionView(ex);
				}
			}
		});

		informationLabel = new JLabel(Language.getInstance().getText("Label_Information" ));	
		erreurLabel = new JLabel(Language.getInstance().getText("vide" ));

		if(!initConnectionMantis()){
			erreurLabel = new JLabel(Language.getInstance().getText("Pb_Config_Mantis"));
			importMantis.setEnabled(false);
			importMantis.setSelected(false);
			selectionImportMantis = false;
		}

		//	 ExtractAttachments configuration file for DB connexion
		boolean trouve = false;
		try {
			prep = SQLWrapper.getSQLCommonQuery("showTable");
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next() && !trouve) {
				String tableName = stmtRes.getString(1);
				if (tableName.equalsIgnoreCase(Language.getInstance().getText("config_extract_attachement"))){
					verifieVersionTableSQL();
					//Rcupre dans Salom le nom du projet
					prep = SQLWrapper.getSQLCommonQuery("recupIDProjet");
					prep.setString(1, proj.getNameFromModel());
					stmtRes = SQLWrapper.runSelectQuery(prep);
					while  (stmtRes.next()) {
						projetID = stmtRes.getInt("id_projet");
					}	
					prep = SQLWrapper.getSQLCommonQuery("selectconfig_extract_attachement");
					prep.setInt(1, projetID);
					stmtRes = SQLWrapper.runSelectQuery(prep);
					if (stmtRes.next()){
						trouve = true;
					}	
				} 
			}	
		} catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_acces_BDD"),
					Language.getInstance().getText("Probleme_config"),
					JOptionPane.WARNING_MESSAGE);
			DetachAttachment.this.dispose();
		} 

		if (trouve==false){
			runConfigWindow();
		}

		try {
			prep = SQLWrapper.getSQLCommonQuery("selectconfig_extract_attachement");
			prep.setInt(1, projetID);
			stmtRes = SQLWrapper.runSelectQuery(prep);
			if (stmtRes.next()){
				LieuStockage = new JLabel(Language.getInstance().getText("Lieu_Stockage") + stmtRes.getString("Salome_EXTRACT_ATTACHMENT_MODE"));
			}	
			if (stmtRes.getString("Salome_EXTRACT_ATTACHMENT_MODE").equalsIgnoreCase("ftpSalome")) {
				ftpSalomeServer = stmtRes.getString("Salome_FTP_SERVER");
				ftpSalomeUser = stmtRes.getString("Salome_FTP_LOGIN");
				ftpSalomePassword = stmtRes.getString("Salome_FTP_PASSWORD");
				if (initConnectionFtp()) {
					Util.log("[FTP] " + listenerSalome.getLog());
					listenerSalome.clearLog();
					ftpSalome.quit();
				}else{
					erreurLabel = new JLabel(Language.getInstance().getText("Pb_Config_FTP"));
					valider.setEnabled(false);
				}
				if(stmtRes.getString("Salome_EXTRACT_ATTACHMENT_MODE").equalsIgnoreCase("File")) {
					File f = new File(stmtRes.getString("Salome_Network_RELATIVE_PATH"));
					if (!f.exists()) {
						erreurLabel = new JLabel(Language.getInstance().getText("Pb_Config_File"));
						valider.setEnabled(false);
					}
				}
			}
		} catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_acces_BDD"),
					Language.getInstance().getText("Probleme_config"),
					JOptionPane.WARNING_MESSAGE);
			runConfigWindow();
		} 

		JPanel InformationPanel = new JPanel();
		InformationPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		InformationPanel.add(informationLabel);

		JPanel MessageErreurPanel = new JPanel();
		MessageErreurPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		MessageErreurPanel.add(erreurLabel);

		JPanel selectPanel = new JPanel();
		selectPanel.setLayout(new BoxLayout(selectPanel, BoxLayout.Y_AXIS));
		selectPanel.setBorder(BorderFactory.createTitledBorder(""));
		selectPanel.add(InformationPanel);

		JPanel MantisPanel = new JPanel();
		MantisPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		MantisPanel.add(importMantis);

		JPanel MantisCarrePanel = new JPanel();
		MantisCarrePanel.setLayout(new BoxLayout(MantisCarrePanel, BoxLayout.Y_AXIS));
		MantisCarrePanel.setBorder(BorderFactory.createTitledBorder(""));
		MantisCarrePanel.add(MantisPanel);

		JPanel ModeStockagePanel = new JPanel();
		ModeStockagePanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		ModeStockagePanel.add(LieuStockage);

		JPanel ModePanel = new JPanel();
		ModePanel.setLayout(new BoxLayout(ModePanel, BoxLayout.Y_AXIS));
		ModePanel.setBorder(BorderFactory.createTitledBorder(""));
		ModePanel.add(ModeStockagePanel);

		JPanel buttons = new JPanel();
		buttons.add(valider);
		buttons.add(annuler);
		buttons.add(parametres);

		JPanel page = new JPanel();
		page.setLayout(new BoxLayout(page, BoxLayout.Y_AXIS));
		page.add(Box.createVerticalStrut(10));
		page.add(InformationPanel);
		page.add(MessageErreurPanel);
		page.add(Box.createVerticalStrut(10));
		page.add(MantisCarrePanel);
		page.add(Box.createVerticalStrut(10));
		page.add(ModePanel);
		page.add(progression);
		page.add(buttons);

		Container contentPaneFrame = this.getContentPane();
		contentPaneFrame.add(page, BorderLayout.CENTER);
		setLocation(400, 100);
		setTitle(Language.getInstance().getText("Extraction"));
		centerScreen();
		}

	protected void centerScreen() {
		Dimension dim = getToolkit().getScreenSize();
		this.pack();
		Rectangle abounds = getBounds();
		setLocation((dim.width - abounds.width) / 2, (dim.height - abounds.height) / 2);	 
		this.setVisible(true); 
		requestFocus();
	}
	
	/**
	 * Lance le dtachement des PJ
	 */
	public void rundetachment(){
		//Met a jour les descriptions des URL de SalomeTMF
		updateURLDatabaseSalome();
		//		 Opens mantis connexion
		try {
			URL _urlBase =  SalomeTMFContext.getInstance().getUrlBase();
			urlTexte = _urlBase.toString();
			urlTexte = urlTexte.substring(0, urlTexte.lastIndexOf("/"));
			urlBase = new URL(urlTexte);

			try{
				prep = SQLWrapper.getSQLCommonQuery("selectconfig_extract_attachement");
				prep.setInt(1, projetID);
				stmtRes = SQLWrapper.runSelectQuery(prep);
				stmtRes.next();
				salomeExportMode = stmtRes.getString("Salome_EXTRACT_ATTACHMENT_MODE");
				repertoireDeBase = stmtRes.getString("Salome_Network_RELATIVE_PATH");
				ftpSalomeServer= stmtRes.getString("Salome_FTP_SERVER");
				ftpSalomeUser = stmtRes.getString("Salome_FTP_LOGIN");
				URL urlSalome = new URL(urlTexte);
				try {
					urlSalome.openStream();
					MD5paswd.readkey(urlSalome);
				}catch (Exception e) {
					MD5paswd.key = new SecretKeySpec(cle.getBytes() , "DES");
				}
				ftpSalomePassword = MD5paswd.decryptString(stmtRes.getString("Salome_FTP_PASSWORD"));
				ftpSalomeDirectory = stmtRes.getString("Salome_FTP_DIRECTORY");
				salomeFTPSortie = stmtRes.getString("Salome_FTP_SORTIE");
				mantisImportMode = stmtRes.getString("MANTIS_INSERT");
				repertoireStockageMantis = stmtRes.getString("MANTIS_Network_RELATIVE_PATH");
				ftpMantisServer= stmtRes.getString("MANTIS_FTP_SERVER");
				ftpMantisUser = stmtRes.getString("MANTIS_FTP_LOGIN");
				try {
					urlSalome.openStream();
					MD5paswd.readkey(urlSalome);
				}catch (Exception e) {
					MD5paswd.key = new SecretKeySpec(cle.getBytes() , "DES");
				}
				ftpMantisPassword = MD5paswd.decryptString(stmtRes.getString("MANTIS_FTP_PASSWORD"));
				ftpMantisDirectory = stmtRes.getString("MANTIS_FTP_DIRECTORY");

			} catch (Exception e) {
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_acces_BDD"),
						Language.getInstance().getText("Probleme_config"),
						JOptionPane.WARNING_MESSAGE);
				DetachAttachment.this.dispose();
			} 

			//Met en place les paramtres pour la configuration rseau
			if(salomeExportMode.equals("File")){
				fs="/";
				File test = new File(repertoireDeBase);
				if (!test.exists()){
					SalomeTMFContext.getInstance().showMessage(
							Language.getInstance().getText("Le_chemin_reseau_existe_pas") + repertoireDeBase,
							Language.getInstance().getText("Probleme_config"),
							JOptionPane.WARNING_MESSAGE);
					runConfigWindow();
				}
			}
			//	Met en place les paramtres pour la configuration Database
			if(salomeExportMode.equals("DB")){
				repertoireDeBase= System.getProperty("java.io.tmpdir");
				fs="/";
			}

			//Met en place les paramtres pour la configuration FTP
			if(salomeExportMode.equals("FTP")){
				if (ftpSalomeDirectory.endsWith("/")){
					repertoireStockage = ftpSalomeDirectory + Language.getInstance().getText("Attachments") + fs + proj.getNameFromModel().replaceAll(" ", "_");
				} else {
					repertoireStockage = ftpSalomeDirectory + fs + Language.getInstance().getText("Attachments") + fs + proj.getNameFromModel().replaceAll(" ", "_");
				} 
				fs="/";
				initConnectionFtp();
			}

//			Met en place les paramtres pour la configuration rseau
			if(mantisImportMode.equals("File")){
				fs="/";
				File test = new File(repertoireStockageMantis);
				if (!test.exists()){
					SalomeTMFContext.getInstance().showMessage(
							Language.getInstance().getText("Le_chemin_reseau_existe_pas") + repertoireStockageMantis,
							Language.getInstance().getText("Probleme_config"),
							JOptionPane.WARNING_MESSAGE);
					runConfigWindow();
				}
			}
		
			//Met en place les paramtres pour la configuration FTP
			if(mantisImportMode.equals("FTP")){
				repertoireStockageMantis= ftpMantisDirectory;
				fs="/";
				if (repertoireStockageMantis.endsWith("/")){
					repertoireStockageMantis = repertoireStockageMantis + Language.getInstance().getText("Attachments") + fs + proj.getNameFromModel().replaceAll(" ", "_");
				} else {
					repertoireStockageMantis = repertoireStockageMantis + fs + Language.getInstance().getText("Attachments") + fs + proj.getNameFromModel().replaceAll(" ", "_");
				}
				initConnectionFtpMantis();
			}
		} catch(Exception ex){
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Verifier_parametres"),
					Language.getInstance().getText("Probleme_config"),
					JOptionPane.WARNING_MESSAGE);
			try {
				runConfigWindow();
			} catch (Exception e) {
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_acces_BDD"),
						Language.getInstance().getText("Probleme_config"),
						JOptionPane.WARNING_MESSAGE);
				DetachAttachment.this.dispose();
			}
		}

		if (proj.getNameFromModel().equals("")){
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_recuperation_Nom_Projet") + proj.getNameFromModel(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
			DetachAttachment.this.dispose();
		}
		
		if(salomeExportMode.equals("DB")){
			repertoireStockage = repertoireDeBase+ fs + Language.getInstance().getText("Attachments") + fs + proj.getNameFromModel().replaceAll(" ", "_");
			makeTreeDirectory(repertoireStockage);
		}

		if(salomeExportMode.equals("File")){
			//Cre le chemin de stockage complet		
			repertoireStockage =repertoireDeBase + fs + Language.getInstance().getText("Attachments") + fs + proj.getNameFromModel().replaceAll(" ", "_");
			makeTreeDirectory(repertoireStockage);
		}

//		Vrifie prsence bdd Salome table attachement	    
		boolean trouve = false;
		try {
			prep = SQLWrapper.getSQLCommonQuery("showTable");
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next() && !trouve) {
				String tableName = stmtRes.getString(1);
				if (tableName.equalsIgnoreCase(Language.getInstance().getText("attachement"))){
					trouve = true;
				} 
			}	
		} catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_acces_BDD"),
					Language.getInstance().getText("Probleme_config"),
					JOptionPane.WARNING_MESSAGE);
			DetachAttachment.this.dispose();
		} 
		
		//initialise les vecteurs des pieces jointes pour executions
		initArrayList(proj.getNameFromModel());
		for (int i = 0; i < vecteurAttachmentExecCas.size(); i += 3) {
			try {
				if (!vecteurAttachmentExecCas.get(i+1).toString().equals("[URL_PLUGIN_ATTACH]")){
					if(salomeExportMode.equals("DB")){
						nouvel_Url = makeExecutionTreeDirectory(vecteurAttachmentExecCas.get(i).toString(),repertoireStockage);
						nouvel_Url = extractFile(vecteurAttachmentExecCas.get(i).toString(), nouvel_Url);
						nouvel_Url = nouvel_Url.replaceAll("\\\\", "/"); 
						nouvel_Url = nouvel_Url.replaceAll("//", "/"); 
						if (nouvel_Url.startsWith("//")){
							nouvel_Url = "file:" + nouvel_Url;	
						}else {
							nouvel_Url = "file://" + nouvel_Url;
						}
						nbPJDetaches= 0;
					}else if(salomeExportMode.equals("File")){
						nouvel_Url = makeExecutionTreeDirectory(vecteurAttachmentExecCas.get(i).toString(),repertoireStockage);
						nouvel_Url = extractFile(vecteurAttachmentExecCas.get(i).toString(), nouvel_Url);
						if (nouvel_Url.startsWith("//")){
							nouvel_Url = "file:" + nouvel_Url;	
						}else {
							nouvel_Url = "file://" + nouvel_Url;
						}
					}else if(salomeExportMode.equals("FTP")){
						initConnectionFtp();
						nouvel_Url = makeExecutionTreeDirectory(vecteurAttachmentExecCas.get(i).toString(),repertoireStockage);
						nouvel_Url = extractFileFTP(vecteurAttachmentExecCas.get(i).toString(), nouvel_Url);
						if (ftpSalomeServer.endsWith("/")){
							nouvel_Url = salomeFTPSortie + "//" + ftpSalomeServer + nouvel_Url.substring(1);
						}else {
							nouvel_Url = salomeFTPSortie + "//" + ftpSalomeServer + nouvel_Url;
						}
					}
					
					if (!salomeExportMode.equals("DB")) {
						updateDatabase(vecteurAttachmentExecCas.get(i).toString(),nouvel_Url);
					}
				}else {
					prep2 = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement2");
					prep2.setString(1, vecteurAttachmentExecCas.get(i).toString());
					stmtRes2 = SQLWrapper.runSelectQuery(prep2);
					if(stmtRes2.next()) {
						nouvel_Url=	stmtRes2.getString("url_attach");
					}
				}
				
				if(selectionImportMantis == true){
					if (!vecteurAttachmentExecCas.get(i+1).equals(Language.getInstance().getText("[MANTIS_ATTACH]"))){
						if (vecteurAttachmentMantisExecCas.contains(vecteurAttachmentExecCas.get(i+2))){
							int positiondansVecteur = vecteurAttachmentMantisExecCas.indexOf(vecteurAttachmentExecCas.get(i+2));
							if (mantisImportMode.equalsIgnoreCase("DB")){
								importDatabaseMantis(vecteurAttachmentMantisExecCas.get(positiondansVecteur-2).toString(), nouvel_Url);
							}else if (mantisImportMode.equalsIgnoreCase("File")){
								importFileMantis(vecteurAttachmentMantisExecCas.get(positiondansVecteur-2).toString(), nouvel_Url);
							} else if (mantisImportMode.equalsIgnoreCase("FTP")){
								importFtpMantis(vecteurAttachmentMantisExecCas.get(positiondansVecteur-2).toString(), nouvel_Url);
							}
						}
					}	
				}	

				if (salomeExportMode.equals("DB")){
					deleteDirectory(new File(repertoireDeBase));
				}

			} catch (Exception e) {
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_Detach") + e.getMessage(),
						Language.getInstance().getText("Probleme_config"),
						JOptionPane.WARNING_MESSAGE);
				e.printStackTrace();
			}
		}

		//Recupre liste autres pices jointes
		initRequirementArrayList(proj.getNameFromModel());
		initFamilleTestArrayList(proj.getNameFromModel());
		initSuiteTestArrayList(proj.getNameFromModel());
		initCasTestArrayList(proj.getNameFromModel());
		initActionTestArrayList(proj.getNameFromModel());
		initEnvironnementArrayList(proj.getNameFromModel());
		initDonneesProjetArrayList(proj.getNameFromModel());
		initCampagneArrayList(proj.getNameFromModel());
		initExecCampagneArrayList(proj.getNameFromModel());
		initResExecCampagneArrayList(proj.getNameFromModel());
		initScriptsArrayList(proj.getNameFromModel());

		for (int i = 0; i < vecteurRequirement.size(); i += 3) {
			try {
				if (salomeExportMode.equals("File")){
					nouvel_Url = extractFile(vecteurRequirement.get(i).toString(),vecteurRequirement.get(i+1).toString());
					if (nouvel_Url.startsWith("//")){
						nouvel_Url = "file:" + nouvel_Url;	
					}else {
						nouvel_Url = "file://" + nouvel_Url;
					}
				}else if(salomeExportMode.equals("FTP")){
					nouvel_Url = extractFileFTP(vecteurRequirement.get(i).toString(), vecteurRequirement.get(i+1).toString());
					if (ftpSalomeServer.endsWith("/")){
						nouvel_Url = salomeFTPSortie + "//" + ftpSalomeServer + nouvel_Url.substring(1);
					}else {
						nouvel_Url = salomeFTPSortie + "//" + ftpSalomeServer + nouvel_Url;
					}
				}
				if (!salomeExportMode.equals("DB")){
					updateDatabase(vecteurRequirement.get(i).toString(),nouvel_Url);
				} 
			} catch (Exception e) {
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_Detach"),
						Language.getInstance().getText("Probleme"),
						JOptionPane.WARNING_MESSAGE);
				e.printStackTrace();
			}
		}
		progress.setIndeterminate(false);
		valider.setEnabled(true);
		annuler.setEnabled(true);
		parametres.setEnabled(true);
		importMantis.setEnabled(true);

		if(salomeExportMode.equals("FTP")){
			try {
				Util.log("[FTP] " + listenerSalome.getLog());
				listenerSalome.clearLog();
				ftpSalome.quit();
			} catch (IOException e) {
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_Commande_ftp") + e.getMessage(),
						Language.getInstance().getText("Probleme"),
						JOptionPane.WARNING_MESSAGE);
				e.printStackTrace();
			} catch (FTPException e) {
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_Commande_ftp") + e.getMessage(),
						Language.getInstance().getText("Probleme"),
						JOptionPane.WARNING_MESSAGE);
				e.printStackTrace();
			}
		}
		if(mantisImportMode.equals("FTP")){
			try {
				Util.log("[FTP] " + listenerMantis.getLog());
				listenerMantis.clearLog();
				ftpMantis.quit();
			} catch (IOException e) {
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_Commande_ftp") + e.getMessage(),
						Language.getInstance().getText("Probleme"),
						JOptionPane.WARNING_MESSAGE);
				e.printStackTrace();
			} catch (FTPException e) {
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_Commande_ftp") + e.getMessage(),
						Language.getInstance().getText("Probleme"),
						JOptionPane.WARNING_MESSAGE);
				e.printStackTrace();
			}
		}

		compactDatabaseTable();
		DataModel.reloadFromBase(true);
		if(selectionImportMantis == true){	
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("nbinsertionMantistexte") + Integer.toString(nbInsertionMantis) + 
					"\n" + Language.getInstance().getText("nbPJdetachestexte") + Integer.toString(nbPJDetaches),
					Language.getInstance().getText("Fin_Extraction"),
					JOptionPane.INFORMATION_MESSAGE);
		}else {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("nbPJdetachestexte") + Integer.toString(nbPJDetaches),
					Language.getInstance().getText("Fin_Extraction"),
					JOptionPane.INFORMATION_MESSAGE);
		}
		DetachAttachment.this.dispose();
	}

	/**
	 * Extrait les fichiers
	 * @param name nom fichier
	 * @param location Lieu de stockage
	 * @return Lieu de stockage
	 * @throws Exception
	 */
	public String extractFile(String name, String location) throws Exception {	
		//cree Arborescence
		makeTreeDirectory(location);

		stmtRes=null;
		try {
			prep = SQLWrapper.getSQLCommonQuery("listeFichier");
			prep.setString(1, name);
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next()) {
				if(!stmtRes.getString("nom_attach").startsWith("http:")){
					location = location + fs + stmtRes.getString("nom_attach");
					File monFichier = new File(location);
					FileOutputStream ostreamImage = new FileOutputStream(monFichier);
					try	{
						InputStream istreamImage = stmtRes.getBinaryStream("contenu_attach");
						byte[] buffer = new byte[1024];
						int length = 0;
						while((length = istreamImage.read(buffer)) != -1) {
							ostreamImage.write(buffer, 0, length);
						}
						nbPJDetaches++;
					}catch (Exception ee){
						SalomeTMFContext.getInstance().showMessage(
								Language.getInstance().getText("Erreur_acces_fichier") + ee.getMessage(),
								Language.getInstance().getText("Probleme"),
								JOptionPane.WARNING_MESSAGE);
					}finally {
						ostreamImage.close();
					}
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}
		return location;
	}

	/**
	 * Extrait les fichiers (mode FTP)
	 * @param name nom fichier
	 * @param location Lieu de stockage
	 * @return Lieu de stockage
	 * @throws Exception
	 */
	public String extractFileFTP(String name, String location) throws Exception {	
		//Rcupre nom fichier
		location = replaceCharacters(location);

		//cree Arborescence
		try {
			ftpSalome.chdir(location);
		}catch (FTPException e){
			String CheminAcreer = "/";
			try {
				StringTokenizer st = new StringTokenizer(location,"/");
				while (st.hasMoreTokens()) {
					CheminAcreer += st.nextToken() + "/";
					try {
						ftpSalome.chdir(CheminAcreer);
					}catch (FTPException ee){
						ftpSalome.mkdir(CheminAcreer);
					}
				}
			}catch (FTPException ee){
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Creation_repertoire_ftp_impossible" + location),
						Language.getInstance().getText("Probleme"),
						JOptionPane.WARNING_MESSAGE);
			}
		}finally{
			ftpSalome.chdir(location);
		}

		stmtRes=null;
		try {
			prep = SQLWrapper.getSQLCommonQuery("listeFichier");
			prep.setString(1, name);
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while (stmtRes.next() ) {
				if(!stmtRes.getString("nom_attach").startsWith("http:")){
					location = location + fs + stmtRes.getString("nom_attach");
					byte[] b = new byte[stmtRes.getBinaryStream("contenu_attach").available()];
					stmtRes.getBinaryStream("contenu_attach").read(b);
					InputStream istreamImage = new ByteArrayInputStream(b);
					ftpSalome.put(istreamImage, stmtRes.getString("nom_attach"));
					nbPJDetaches++;
					istreamImage.close();
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_Commande_ftp") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
			e.printStackTrace();
		}
		return location;
	}

	/**
	 * importe les fichiers dans Mantis
	 * @param ID_MANTIS IdMantis
	 * @param URLFichier Url de stockage du fichier
	 * @throws Exception
	 */
	public void importDatabaseMantis(String ID_MANTIS, String URLFichier) throws Exception{
		String URLMantis=null;
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement2");
			prep.setString(1, ID_MANTIS);
			stmtRes = SQLWrapper.runSelectQuery(prep);
			stmtRes.first();
			URLMantis= stmtRes.getString("url_attach");
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_Mantis_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
			e.printStackTrace();
		}

		String ID_Mantis2 = URLMantis.substring(URLMantis.lastIndexOf("&bug_id=")+8,URLMantis.lastIndexOf("&user_id="));
		String location;
		if (URLFichier.startsWith("file:")){
			if(URLFichier.indexOf(":/") == 9){
				location = URLFichier.substring(7,URLFichier.length());
			} else {
				location = URLFichier.substring(5,URLFichier.length());
			}
		} else if (URLFichier.startsWith("http:")){
			location = URLFichier.substring(4,URLFichier.length());
		} else if (URLFichier.startsWith("ftpSalome:")){
			location = URLFichier.substring(3,URLFichier.length());
		} else {
			location = URLFichier;
		}
		NomPJ= URLFichier.substring(URLFichier.lastIndexOf("/")+1,URLFichier.length());
		
		//Verification PJ pas encore prsente
		try {
			PreparedStatement ps = iDB.prepareStatement("SELECT * from `mantis_bug_file_table` where bug_id = ? AND filename = ?");
			ps.setString(1, ID_Mantis2); 
			ps.setString(2, NomPJ);
			stmtRes = ps.executeQuery();
			if (!stmtRes.next()){
				InputStream istreamImage=null;
				PreparedStatement ps2 = iDB.prepareStatement("insert into `mantis_bug_file_table`  (bug_id, content, filename, filesize, date_added) values (?,?,?,?,?)");
				try 
				{
					long TailleImage=0;
					//Insertion piece jointe
					if(salomeExportMode.equals("FTP")){
						if (location.startsWith(Language.getInstance().getText("ftp2p"))){
							ftpSalome.chdir(location.substring(ftpSalomeServer.length()+6,location.lastIndexOf("/")));
						}
						if (location.startsWith(Language.getInstance().getText("http2p"))){
							ftpSalome.chdir(location.substring(ftpSalomeServer.length()+7,location.lastIndexOf("/")));
						}
						
						TailleImage = ftpSalome.size(NomPJ);
						istreamImage = new ByteArrayInputStream(ftpSalome.get(NomPJ));

						ps2.setString(1, ID_Mantis2);
						ps2.setBinaryStream(2, istreamImage, (int) TailleImage);
						ps2.setString(3, NomPJ);
						ps2.setInt(4, (int) TailleImage);
						//ps2.setDate(5, sqlDate); 
						ps2.setTimestamp(5, sqlDate); 
						ps2.executeUpdate();
						nbInsertionMantis++;
						istreamImage.close();
					}else if(salomeExportMode.equals("DB")||salomeExportMode.equals("File")){
						if (location.startsWith("//") && location.contains(":/")){
							location = location.substring(2);
						}
						File monImage = new File(location);
						TailleImage = monImage.length();
						FileInputStream isFiletreamImage = new FileInputStream(monImage);
						ps2.setString(1, ID_Mantis2);
						ps2.setBinaryStream(2, isFiletreamImage, (int) TailleImage);
						ps2.setString(3, NomPJ);
						ps2.setInt(4, (int) TailleImage);
//						ps2.setDate(5, sqlDate); 
						ps2.setTimestamp(5, sqlDate); 
						ps2.executeUpdate();
						nbInsertionMantis++;
						isFiletreamImage.close();
					}
				}catch(Exception e) {
					SalomeTMFContext.getInstance().showMessage(
							Language.getInstance().getText("Erreur_Mantis_SQL") + e.getMessage(),
							Language.getInstance().getText("Probleme"),
							JOptionPane.WARNING_MESSAGE);
					e.printStackTrace();
				}finally{
					ps2.close();
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_Mantis_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
			e.printStackTrace();
		}
	}

	/**
	 * importe les fichiers dans Mantis (FTP)
	 * @param ID_MANTIS IdMantis
	 * @param URLFichier Url de stockage du fichier
	 */
	public void importFtpMantis(String ID_MANTIS, String URLFichier) {
		String URLMantis=null;
		initConnectionFtpMantis();

		try {
			prep = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement2");
			prep.setString(1, ID_MANTIS);
			stmtRes = SQLWrapper.runSelectQuery(prep);
			stmtRes.first();
			URLMantis= stmtRes.getString("url_attach");
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_Mantis_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
			e.printStackTrace();
		}

		ID_Mantis2 = URLMantis.substring(URLMantis.lastIndexOf("&bug_id=")+8,URLMantis.lastIndexOf("&user_id="));
		if (URLFichier.startsWith("file:")){
			URLFichier = URLFichier.substring(5);
			if(URLFichier.indexOf(":/") == 3){
				location = URLFichier.substring(2,URLFichier.length());
			} else {
				location = URLFichier;
			}
		} else if (URLFichier.startsWith("http:")){
			location = URLFichier.substring(6,URLFichier.length());
		} else if (URLFichier.startsWith("ftp:")){
			location = URLFichier.substring(5,URLFichier.length());
		} else {
			location = URLFichier;
		}

		NomPJ= URLFichier.substring(URLFichier.lastIndexOf("/")+1,URLFichier.length());
		repFtpMantis = location.substring(repertoireDeBase.length(),location.lastIndexOf("/"));
		if (!ftpMantisDirectory.equals("/")){
			if (!ftpMantisDirectory.startsWith("/")){
			ftpMantisDirectory = "/" + ftpMantisDirectory;
			}
			if (!ftpMantisDirectory.endsWith("/")){
			ftpMantisDirectory = ftpMantisDirectory+ "/";
			}
		}
		repFtpSalome =  repFtpMantis.substring(ftpSalomeServer.length() + 1 );
		if (!repFtpSalome.startsWith("/")){
			repFtpSalome = "/" + repFtpSalome;
		}
		if (!repFtpSalome.endsWith("/")){
			repFtpSalome = repFtpSalome + "/";
		}
		if (salomeExportMode.equals("FTP")){
			repFtpMantis = repFtpMantis.substring(ftpSalomeServer.length() + ftpSalomeDirectory.length() + 1 );
			repFtpMantis = ftpMantisDirectory + repFtpMantis + "/";
		}
		
			System.out.println("*********************************************** ");
			System.out.println("repFtpMantis " + repFtpMantis);
			System.out.println("repFtpSalome " + repFtpSalome);
			System.out.println("*********************************************** ");
		//Verification PJ pas encore prsente
		try {
			PreparedStatement ps = iDB.prepareStatement("SELECT * from `mantis_bug_file_table` where bug_id = ? AND filename = ?");
			ps.setString(1, ID_Mantis2); 
			ps.setString(2, NomPJ);
			stmtRes = ps.executeQuery();
			if (!stmtRes.next()){
				InputStream istreamImage=null;
				PreparedStatement ps2 = iDB.prepareStatement("insert into `mantis_bug_file_table`  (bug_id,  filename, filesize, diskfile, folder, date_added) values (?,?,?,?,?,?)");
				try 
				{
					long TailleImage=0;
					if (!repFtpMantis.startsWith("/")){
						repFtpMantis = "/" + repFtpMantis;
					}
					if (!repFtpMantis.endsWith("/")){
						repFtpMantis = repFtpMantis + "/";
					}

//					cree Arborescence
					try {
						ftpMantis.chdir(repFtpMantis);
					}catch (FTPException e){
						String CheminAcreer = "/";
						try {
							StringTokenizer st = new StringTokenizer(repFtpMantis,"/");
							while (st.hasMoreTokens()) {
								CheminAcreer += st.nextToken() + "/";
								try {
									ftpMantis.chdir(CheminAcreer);
									}catch (FTPException ee){
									ftpMantis.mkdir(CheminAcreer);
								}
							}
						}catch (FTPException ee){
							SalomeTMFContext.getInstance().showMessage(
									Language.getInstance().getText("Creation_repertoire_ftp_impossible" + location),
									Language.getInstance().getText("Probleme"),
									JOptionPane.WARNING_MESSAGE);
						}
					}finally{
						ftpMantis.chdir(repFtpMantis);
					}

					//Insertion piece jointe
					if (salomeExportMode.equals("DB")||salomeExportMode.equals("File")){
						File monImage = new File(location);
						TailleImage = monImage.length();
						FileInputStream isFiletreamImage = new FileInputStream(monImage);
						ftpMantis.put(isFiletreamImage, NomPJ);
						isFiletreamImage.close();
					}

					//Insertion piece jointe
					if (salomeExportMode.equals("FTP")){
						ftpSalome.chdir(repFtpSalome);
						byte[] b = ftpSalome.get(repFtpSalome + "/" + NomPJ);
						TailleImage = ftpSalome.size(repFtpSalome + "/" + NomPJ);
						istreamImage = new ByteArrayInputStream(b);
						ftpMantis.put(istreamImage, NomPJ);
						istreamImage.close();
					}

					ps2.setString(1, ID_Mantis2);
					ps2.setString(2, NomPJ);
					ps2.setInt(3, (int) TailleImage);
					String test1 = "ftp://" + ftpMantisUser + ":" + ftpMantisPassword + "@" + ftpMantisServer + repFtpMantis;
					ps2.setString(4, test1 + NomPJ);
					ps2.setString(5, test1);
//					ps2.setDate(6, sqlDate); 
					ps2.setTimestamp(6, sqlDate); 
					ps2.executeUpdate();
					nbInsertionMantis++;
			}catch(Exception e) {
					SalomeTMFContext.getInstance().showMessage(
							Language.getInstance().getText("Erreur_Mantis_SQL") + e.getMessage(),
							Language.getInstance().getText("Probleme"),
							JOptionPane.WARNING_MESSAGE);
					e.printStackTrace();
				}finally{
					ps2.close();
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_Mantis_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
			e.printStackTrace();
		}
	}

	/**
	 * importe les fichiers dans Mantis (Rpertoire)
	 * @param ID_MANTIS IdMantis
	 * @param URLFichier Url de stockage du fichier
	 */
	public void importFileMantis(String ID_MANTIS, String URLFichier) {
		String URLMantis=null;
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement2");
			prep.setString(1, ID_MANTIS);
			stmtRes = SQLWrapper.runSelectQuery(prep);
			stmtRes.first();
			URLMantis= stmtRes.getString("url_attach");
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_Mantis_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
			e.printStackTrace();
		}

		ID_Mantis2 = URLMantis.substring(URLMantis.lastIndexOf("&bug_id=")+8,URLMantis.lastIndexOf("&user_id="));
		if (URLFichier.startsWith("file:")){
			URLFichier = URLFichier.substring(5);
			if(URLFichier.indexOf(":/") == 3){
				location = URLFichier.substring(2,URLFichier.length());
			} else {
				location = URLFichier;
			}
		} else if (URLFichier.startsWith("http:")){
			location = URLFichier.substring(6,URLFichier.length());
		} else if (URLFichier.startsWith("ftp:")){
			location = URLFichier.substring(5,URLFichier.length());
		} else {
			location = URLFichier;
		}
		NomPJ= URLFichier.substring(URLFichier.lastIndexOf("/")+1,URLFichier.length());
		//Verification PJ pas encore prsente
		try {
			PreparedStatement ps = iDB.prepareStatement("SELECT * from `mantis_bug_file_table` where bug_id = ? AND filename = ?");
			ps.setString(1, ID_Mantis2); 
			ps.setString(2, NomPJ);
			stmtRes = ps.executeQuery();
			if (!stmtRes.next()){
				InputStream istreamImage=null;
				boolean insertDansMantis = false;
				PreparedStatement ps2 = iDB.prepareStatement("insert into `mantis_bug_file_table`  (bug_id,  filename, filesize, diskfile, folder,date_added) values (?,?,?,?,?,?)");
				try 
				{
					long TailleImage=0;
					//Insertion piece jointe
					if(salomeExportMode.equals("File")){
						File monImage = new File(location);
						TailleImage = monImage.length();
						while (!location.substring(repertoireDeBase.length()).startsWith("/")){
							location = location.substring(1);
						}
						if (location.substring(repertoireDeBase.length(),location.lastIndexOf("/")).startsWith("/")){
							RepertoirePJMantis = repertoireStockageMantis + location.substring(repertoireDeBase.length(),location.lastIndexOf("/"));
						}else {
							RepertoirePJMantis = repertoireStockageMantis + fs + location.substring(repertoireDeBase.length(),location.lastIndexOf("/"));
						}
						if (!location.equals(RepertoirePJMantis + fs + NomPJ)){
							makeTreeDirectory(RepertoirePJMantis);
							File destination= new File(RepertoirePJMantis + fs + NomPJ); 
							insertDansMantis = copyFile (monImage, destination);
						} else {
							File destination= new File(RepertoirePJMantis + fs + NomPJ); 
							if (destination.exists()){
								insertDansMantis =true;
							}else {
								insertDansMantis = false;
							}
						}

					}else if(salomeExportMode.equals("FTP")){
						ftpSalome.chdir(location.substring(ftpSalomeServer.length()+1,location.lastIndexOf("/")));
						byte[] b = ftpSalome.get(location.substring(location.lastIndexOf("/")+1,location.length()));
						TailleImage = ftpSalome.size(location.substring(location.lastIndexOf("/")+1,location.length()));
						istreamImage = new ByteArrayInputStream(b);
						if (location.startsWith("/")){
							RepertoirePJMantis = repertoireStockageMantis + fs + Language.getInstance().getText("Attachments") + fs + proj.getNameFromModel().replaceAll(" ", "_") + location.substring(ftpSalomeServer.length()+1,location.lastIndexOf("/"));
						}else {
							RepertoirePJMantis = repertoireStockageMantis + fs+ Language.getInstance().getText("Attachments") + fs + proj.getNameFromModel().replaceAll(" ", "_")+ fs + location.substring(ftpSalomeServer.length()+1,location.lastIndexOf("/"));
						}
						makeTreeDirectory(RepertoirePJMantis);
						File monFichier = new File(RepertoirePJMantis + fs + location.substring(location.lastIndexOf("/")+1,location.length()));
						//monFichier.createNewFile();
						FileOutputStream ostreamImage = new FileOutputStream(monFichier);
						byte[] buffer = new byte[1024];
						int length = 0;
						while((length = istreamImage.read(buffer)) != -1) {
							ostreamImage.write(buffer, 0, length);
						}
						ostreamImage.close();
						istreamImage.close();
						insertDansMantis = true;

					}else if (salomeExportMode.equals("DB")){
						File monImage = new File(location);
						TailleImage = monImage.length();
						RepertoirePJMantis = repertoireStockageMantis + fs + location.substring(repertoireDeBase.length(),location.lastIndexOf("/"));
						makeTreeDirectory(RepertoirePJMantis);
						File destination= new File(RepertoirePJMantis + fs + NomPJ); 
						insertDansMantis = copyFile (monImage, destination);
					}

					ps2.setString(1, ID_Mantis2);
					ps2.setString(2, NomPJ);
					ps2.setInt(3, (int) TailleImage);
					ps2.setString(4, RepertoirePJMantis + fs + NomPJ);
					ps2.setString(5, RepertoirePJMantis);
//					ps2.setDate(6, sqlDate); 
					ps2.setTimestamp(6, sqlDate); 
					if (insertDansMantis==true) {
						ps2.executeUpdate();
						nbInsertionMantis++;
					}


				}catch(Exception e) {
					SalomeTMFContext.getInstance().showMessage(
							Language.getInstance().getText("Erreur_Mantis_SQL") + e.getMessage(),
							Language.getInstance().getText("Probleme"),
							JOptionPane.WARNING_MESSAGE);
					e.printStackTrace();
				}finally{
					ps2.close();
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_Mantis_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
			e.printStackTrace();
		}
	}

	
	/**
	 * Fonction de copie de fichiers
	 * @param source Fichier source
	 * @param destination Fichier de destination
	 * @return fichier de destination
	 */
	public boolean copyFile (File source, File destination){
		// Cration du fichier :
		try {
			destination.createNewFile();
			// Ouverture des flux
			FileInputStream sourceFile = new java.io.FileInputStream(source);
			FileOutputStream destinationFile = new java.io.FileOutputStream(destination);

			// Lecture par segment de 0.5Mo 
			byte buffer[]=new byte[512*1024];
			int nbLecture;
			while( (nbLecture = sourceFile.read(buffer)) != -1 ) {
				destinationFile.write(buffer, 0, nbLecture);
			} 
			return true;
		} catch (IOException e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_Detach") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
			e.printStackTrace();
			return false;
		}  
	}

	/**
	 * Initialise la connecttion avec Mantis
	 * @return boolean
	 */
	public boolean initConnectionMantis(){
		//Opens mantis connexion
		ConnexionMantisOK=false;
		try {
			URL _urlBase =  SalomeTMFContext.getInstance().getUrlBase();
			urlTexte = _urlBase.toString();
			urlTexte = urlTexte.substring(0, urlTexte.lastIndexOf("/"));
			URL urlBase = new URL(urlTexte);

			// Mantis configuration file for DB connexion
			java.net.URL url_cfg = new java.net.URL(urlBase	+ MANTIS_CFG_FILE_SALOME);
			try {
				cfg_prop = Util.getPropertiesFile(url_cfg);
			} catch (Exception e) {
				cfg_prop = Util.getPropertiesFile(MANTIS_CFG_FILE_SALOME);
			}

			driver_Mantis = cfg_prop.getProperty("JDBC_DRIVER");
			url_Db_Mantis = cfg_prop.getProperty("MANTIS_URL_DB");
			user_Mantis = cfg_prop.getProperty("MANTIS_USER_LOGIN");
			pwd_Mantis = cfg_prop.getProperty("MANTIS_USER_PWD");
			url_Http_Mantis = cfg_prop.getProperty("MANTIS_URL_HTTP");

			if (!Api.isIDE_DEV()) {
				try {
					pwd_Mantis = org.objectweb.salome_tmf.api.MD5paswd.decryptString(pwd_Mantis);
				} catch (Exception e) {
					Util.log("[MantisPlugin] Clear pwd used for Mantis");
				}
			}

			mantis_Host = cfg_prop.getProperty("MANTIS_URL_HTTP");
			Util.log("[MantisPlugin] MANTIS open database : " + ", "
					+ driver_Mantis + ", " + url_Db_Mantis + ", " + user_Mantis + ", " + pwd_Mantis);
			if (!mantis_Host.endsWith("/"))
				mantis_Host = mantis_Host + "/";

			ISQLObjectFactory iSQL_OF = Api.getISQLObjectFactory();
			if (iDB == null){
				iDB = iSQL_OF.getInstanceOfDataBase(driver_Mantis);
				iDB.open(url_Db_Mantis,user_Mantis,pwd_Mantis);
				ConnexionMantisOK=true;
			}
		} catch (Exception E) {
			E.printStackTrace();
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Plugin_non_charge"),
					Language.getInstance().getText("Probleme_config"),
					JOptionPane.WARNING_MESSAGE);
			}
		return ConnexionMantisOK;
	}

	/**
	 * @param name
	 * @param location
	 * @return location
	 * @throws Exception
	 */
	public String  makeExecutionTreeDirectory(String name, String location) throws Exception {
		String finLocation=null;
		String idExecCas=null;
		if (vecteurAttachmentExecCas.contains(name)){
			int i = vecteurAttachmentExecCas.indexOf(name);
			idExecCas= vecteurAttachmentExecCas.get(i+2).toString();
		}
		String idResExec=null;
		if (vecteurExecCas.contains(idExecCas)){
			int i = vecteurExecCas.indexOf(idExecCas);
			idResExec= vecteurExecCas.get(i+2).toString();
			prep = SQLWrapper.getSQLCommonQuery("recupNomTest");
			prep.setString(1, vecteurExecCas.get(i+1).toString());
			stmtRes = SQLWrapper.runSelectQuery(prep);
			stmtRes.first();
			finLocation = stmtRes.getString("nom_cas");
		}
		String idExec=null;
		if (vecteurResExecCampagne.contains(idResExec)){
			int i = vecteurResExecCampagne.indexOf(idResExec);
			idExec= vecteurResExecCampagne.get(i+2).toString();
			finLocation = vecteurResExecCampagne.get(i+1).toString() + "/" + finLocation;
		}
		String idCamp=null;
		if (vecteurExecCampagne.contains(idExec)){
			int i = vecteurExecCampagne.indexOf(idExec);
			idCamp= vecteurExecCampagne.get(i+2).toString();
			finLocation = vecteurExecCampagne.get(i+1).toString() + "/" + finLocation;
		}
//		String idprojet=null;
		if (vecteurCampagneTest.contains(idCamp)){
			int i = vecteurCampagneTest.indexOf(idCamp);
//			idprojet= vecteurCampagneTest.get(i+2).toString();
			finLocation = vecteurCampagneTest.get(i+1).toString() + "/" + finLocation;
		}
		location = replaceCharacters(location + fs + finLocation);
		return location;
	}

	/**
	 * @param IdAttach
	 * @param urlDeRemplacement
	 */
	public void updateDatabase(String IdAttach, String urlDeRemplacement){
		try {
			prep = SQLWrapper.getSQLCommonQuery("effaceLigneAttachment" );
			prep.setString(1, IdAttach);
			SQLWrapper.runDeleteQuery(prep);
			Date creation_ts = Util.getCurrentDate();
			prep = SQLWrapper.getSQLCommonQuery("insertLigneAttachment");
			prep.setString(1, IdAttach);
			prep.setString(2, urlDeRemplacement);
			prep.setDate(3, creation_ts);
			SQLWrapper.runAddQuery(prep);
		} catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		} 
	}

	/**
	 * @throws HeadlessException
	 * @throws Exception
	 */
	public void runConfigWindow() throws HeadlessException, Exception {
		FenetreSaisieConfig f = new FenetreSaisieConfig(javax.swing.JOptionPane.getFrameForComponent(DetachAttachment.this), pIhm, isConnexionMantisOK());
	/*	}else {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("VousDevezEtreAdminDuProjet"),
					Language.getInstance().getText("Information"),
					JOptionPane.WARNING_MESSAGE);
			DetachAttachment.this.dispose();
		}*/
	}

	/**
	 * Efface le rpertoire indiqu en paramtre
	 * @param path
	 * @return boolean
	 */
	static public boolean deleteDirectory(File path) { 
		boolean resultat = true; 

		if( path.exists() ) { 
			File[] files = path.listFiles(); 
			for(int i=0; i<files.length; i++) { 
				if(files[i].isDirectory()) { 
					resultat &= deleteDirectory(files[i]); 
				} 
				else { 
					resultat &= files[i].delete(); 
				} 
			} 
		} 
		resultat &= path.delete(); 
		return( resultat ); 
	} 

	/**
	 * 
	 */
	public void updateURLDatabaseSalome() {
		try {
			prep = SQLWrapper.getSQLCommonQuery("miseAJourURLBDDSalome");
			SQLWrapper.runUpdateQuery(prep);
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}
	}

	/**
	 * Compacte la base de donnes
	 */
	public void compactDatabaseTable(){
		try {
			prep = SQLWrapper.getSQLCommonQuery("compactagetableattachment");
			stmtRes = SQLWrapper.runSelectQuery(prep);
		} catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("erreur_compactage_base"),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}

	}

	/**
	 * Initialise la conneciont FTP 
	 * @return boolean
	 */
	public boolean initConnectionFtp() {
		ftpSalome = new FTPClient();
		try {
			ftpSalome.setRemoteHost(ftpSalomeServer);
			listenerSalome = new FTPMessageCollector();
			ftpSalome.setMessageListener(listenerSalome);
			//  connect
			ftpSalome.connect();
			// login
			ftpSalome.login(ftpSalomeUser, ftpSalomePassword);
			Util.log("[FTP] " + listenerSalome.getLog());
			listenerSalome.clearLog();
			ftpSalome.setType(FTPTransferType.BINARY);
			return true;
		} catch (FTPException e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_Commande_ftp") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
			e.printStackTrace();
			return false;
		} catch (IOException e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_Commande_ftp") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
			e.printStackTrace();
			return false;
		}
	}

	/**
	 * Initialise la connexion FTP pour Mantis
	 * @return boolean
	 */
	public boolean initConnectionFtpMantis() {
		ftpMantis = new FTPClient();
		try {
			ftpMantis.setRemoteHost(ftpMantisServer);
			listenerMantis = new FTPMessageCollector();
			ftpMantis.setMessageListener(listenerMantis);
			//  connect
			ftpMantis.connect();
			// login
			ftpMantis.login(ftpMantisUser, ftpMantisPassword);
			Util.log("[FTP] " + listenerMantis.getLog());
			listenerMantis.clearLog();
			ftpMantis.setType(FTPTransferType.BINARY);
			return true;
		} catch (FTPException e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_Commande_ftp") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
			e.printStackTrace();
			return false;
		} catch (IOException e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_Commande_ftp") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
			e.printStackTrace();
			return false;
		}
	}

	/**
	 * Enleve les caractres accentus
	 * @param location
	 * @return location
	 */
	public String replaceCharacters(String location){
		location = location.replaceAll("", "e");
		location = location.replaceAll("", "e");
		location = location.replaceAll("", "e");
		location = location.replaceAll("", "a");
		location = location.replaceAll("", "u");
		location = location.replaceAll(" ", "_");
		return location;
	}

	/**
	 * Gnre l'arborescence des rpertoires
	 * @param repertoire
	 */
	public void makeTreeDirectory (String repertoire){
		File faitArbores = new File(repertoire);
		if  (!faitArbores.exists()) {
			try {
				faitArbores.mkdirs();
			}catch (Exception e){
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_acces_repertoire") + faitArbores,
						Language.getInstance().getText("Probleme"),
						JOptionPane.WARNING_MESSAGE);
			}
		}
	}

	/**
	 * Initalise la lste des pices jointes
	 * @param nomProjet
	 */
	public void initRequirementArrayList(String nomProjet){	
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupAttachmentRequirement");
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next()) {
				String location="";
				int idparent= stmtRes.getInt("REQUIREMENTS_id_req");
				while  (idparent!=0) {
					prep2 = SQLWrapper.getSQLCommonQuery("recupNomRequirement");
					prep2.setInt(1, idparent);
					prep2.setInt(2, projetID);
					stmtRes2 = SQLWrapper.runSelectQuery(prep2);
					stmtRes2.first();
					location =  stmtRes2.getString("req_name") + fs + location;
					idparent = stmtRes2.getInt("id_req_parent");
				}
				location = repertoireStockage + fs + "Requirements" + fs + location;
				location = location.substring(0,location.length()-2);
				prep2 = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement");
				prep2.setInt(1, stmtRes.getInt("ATTACHEMENT_id_attach"));
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				if (stmtRes2.first()) {
					stmtRes2.first();
					vecteurRequirement.add(Integer.toString(stmtRes.getInt("ATTACHEMENT_id_attach")));
					vecteurRequirement.add(location.replaceAll(" ","_"));
					vecteurRequirement.add(stmtRes2.getString("nom_attach"));
				}
			}

		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}
	}
	
	/**
	 * Initalise la lste des pices jointes
	 * @param nomProjet
	 */
	public void initFamilleTestArrayList(String nomProjet){	
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupAttachmentFamilleTest");
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next()) {
				String location="";
				int idFamille= stmtRes.getInt("FAMILLE_TEST_id_famille");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomFamille");
				prep2.setInt(1, idFamille);
				prep2.setInt(2, projetID);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				stmtRes2.first();
				location = stmtRes2.getString("nom_famille") ;
				location = repertoireStockage + fs + "Plan de tests" + fs + location;
				prep2 = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement");
				prep2.setInt(1, stmtRes.getInt("ATTACHEMENT_id_attach"));
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				if (stmtRes2.first()){
					stmtRes2.first();
					vecteurRequirement.add(Integer.toString(stmtRes.getInt("ATTACHEMENT_id_attach")));
					vecteurRequirement.add(location.replaceAll(" ","_"));
					vecteurRequirement.add(stmtRes2.getString("nom_attach"));
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}
	}	

	/**
	 * Initalise la lste des pices jointes
	 * @param nomProjet
	 */
	public void initSuiteTestArrayList(String nomProjet){	
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupAttachmentsuiteTest");
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next()) {
				String location="";
				int idSuite= stmtRes.getInt("SUITE_TEST_id_suite");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomSuite");
				prep2.setInt(1, idSuite);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				stmtRes2.first();
				int idFamille = stmtRes2.getInt("FAMILLE_TEST_id_famille");
				location = stmtRes2.getString("nom_suite");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomFamille");
				prep2.setInt(1, idFamille);
				prep2.setInt(2, projetID);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				if(stmtRes2.first()){
					location = stmtRes2.getString("nom_famille") + fs + location ;
					location = repertoireStockage + fs + "Plan de tests" + fs + location;
					prep2 = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement");
					prep2.setInt(1, stmtRes.getInt("ATTACHEMENT_id_attach"));
					stmtRes2 = SQLWrapper.runSelectQuery(prep2);
					if (stmtRes2.first()) {
						stmtRes2.first();
						vecteurRequirement.add(Integer.toString(stmtRes.getInt("ATTACHEMENT_id_attach")));
						vecteurRequirement.add(location.replaceAll(" ","_"));
						vecteurRequirement.add(stmtRes2.getString("nom_attach"));
					}
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}
	}	

	/**
	 * Initalise la lste des pices jointes
	 * @param nomProjet
	 */
	public void initCasTestArrayList(String nomProjet){	
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupAttachmentCasTest");
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next()) {
				String location="";
				int idCas= stmtRes.getInt("CAS_TEST_id_cas");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomCas");
				prep2.setInt(1, idCas);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				stmtRes2.first();
				location = stmtRes2.getString("nom_cas");
				int idSuite= stmtRes2.getInt("SUITE_TEST_id_suite");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomSuite");
				prep2.setInt(1, idSuite);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				stmtRes2.first();
				int idFamille = stmtRes2.getInt("FAMILLE_TEST_id_famille");
				location = stmtRes2.getString("nom_suite") + fs + location;
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomFamille");
				prep2.setInt(1, idFamille);
				prep2.setInt(2, projetID);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				if(stmtRes2.first()){
					location = stmtRes2.getString("nom_famille") + fs + location ;
					location = repertoireStockage + fs + "Plan de tests" + fs + location;
					prep2 = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement");
					prep2.setInt(1, stmtRes.getInt("ATTACHEMENT_id_attach"));
					stmtRes2 = SQLWrapper.runSelectQuery(prep2);
					if (stmtRes2.first()) {
						stmtRes2.first();
						vecteurRequirement.add(Integer.toString(stmtRes.getInt("ATTACHEMENT_id_attach")));
						vecteurRequirement.add(location.replaceAll(" ","_"));
						vecteurRequirement.add(stmtRes2.getString("nom_attach"));
					}
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}
	}	

	/**
	 * Initalise la lste des pices jointes
	 * @param nomProjet
	 */
	public void initActionTestArrayList(String nomProjet){	
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupAttachmentActionTest");
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next()) {
				String location="";
				int idAction = stmtRes.getInt("ACTION_TEST_id_action");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomAction");
				prep2.setInt(1, idAction);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				stmtRes2.first();
				location = stmtRes2.getString("nom_action");
				int idCas= stmtRes2.getInt("CAS_TEST_id_cas");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomCas");
				prep2.setInt(1, idCas);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				stmtRes2.first();
				location = stmtRes2.getString("nom_cas") + fs + location ;
				int idSuite= stmtRes2.getInt("SUITE_TEST_id_suite");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomSuite");
				prep2.setInt(1, idSuite);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				stmtRes2.first();
				int idFamille = stmtRes2.getInt("FAMILLE_TEST_id_famille");
				location = stmtRes2.getString("nom_suite") + fs + location;
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomFamille");
				prep2.setInt(1, idFamille);
				prep2.setInt(2, projetID);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				if(stmtRes2.first()){
					location = stmtRes2.getString("nom_famille") + fs + location ;
					location = repertoireStockage + fs + "Plan de tests" + fs + location;
					prep2 = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement");
					prep2.setInt(1, stmtRes.getInt("ATTACHEMENT_id_attach"));
					stmtRes2 = SQLWrapper.runSelectQuery(prep2);
					if (stmtRes2.first()) {
						stmtRes2.first();
						vecteurRequirement.add(Integer.toString(stmtRes.getInt("ATTACHEMENT_id_attach")));
						vecteurRequirement.add(location.replaceAll(" ","_"));
						vecteurRequirement.add(stmtRes2.getString("nom_attach"));
					}
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}
	}	

	/**
	 * Initalise la lste des pices jointes
	 * @param nomProjet
	 */
	public void initEnvironnementArrayList(String nomProjet){	
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupAttachmentEnvironnement");
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next()) {
				String location="";
				int idEnvironnement= stmtRes.getInt("ENVIRONNEMENT_id_env");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomEnvironnement");
				prep2.setInt(1, idEnvironnement);
				prep2.setInt(2, projetID);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				stmtRes2.first();
				location = stmtRes2.getString("nom_env") ;
				location = repertoireStockage + fs + "environnement" + fs + location;
				prep2 = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement");
				prep2.setInt(1, stmtRes.getInt("ATTACHEMENT_id_attach"));
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				if (stmtRes2.first()) {
					stmtRes2.first();
					vecteurRequirement.add(Integer.toString(stmtRes.getInt("ATTACHEMENT_id_attach")));
					vecteurRequirement.add(location.replaceAll(" ","_"));
					vecteurRequirement.add(stmtRes2.getString("nom_attach"));
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}
	}	

	/**
	 * Initalise la lste des pices jointes
	 * @param nomProjet
	 */
	public void initDonneesProjetArrayList(String nomProjet){	
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupAttachmentDonneesProjet");
			prep.setInt(1, projetID);
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next()) {
				String location = repertoireStockage;
				prep2 = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement");
				prep2.setInt(1, stmtRes.getInt("ATTACHEMENT_id_attach"));
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				if (stmtRes2.first()) {
					stmtRes2.first();
					vecteurRequirement.add(Integer.toString(stmtRes.getInt("ATTACHEMENT_id_attach")));
					vecteurRequirement.add(location.replaceAll(" ","_"));
					vecteurRequirement.add(stmtRes2.getString("nom_attach"));
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}
	}	

	/**
	 * Initalise la lste des pices jointes
	 * @param nomProjet
	 */
	public void initCampagneArrayList(String nomProjet){	
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupAttachmentCampagne");
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next()) {
				String location="";
				int idCampagne= stmtRes.getInt("CAMPAGNE_TEST_id_camp");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomCampagne");
				prep2.setInt(1, idCampagne);
				prep2.setInt(2, projetID);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				if(stmtRes2.first()){
					location = stmtRes2.getString("nom_camp");
					location = repertoireStockage + fs + location;
					prep2 = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement");
					prep2.setInt(1, stmtRes.getInt("ATTACHEMENT_id_attach"));
					stmtRes2 = SQLWrapper.runSelectQuery(prep2);
					if (stmtRes2.first()) {
						stmtRes2.first();
						vecteurRequirement.add(Integer.toString(stmtRes.getInt("ATTACHEMENT_id_attach")));
						vecteurRequirement.add(location.replaceAll(" ","_"));
						vecteurRequirement.add(stmtRes2.getString("nom_attach"));
					}
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}
	}	

	/**
	 * Initalise la lste des pices jointes
	 * @param nomProjet
	 */
	public void initExecCampagneArrayList(String nomProjet){	
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupAttachmentExecCampagne");
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next()) {
				String location="";
				int idExecCampagne= stmtRes.getInt("EXEC_CAMP_id_exec_camp");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomExecCampagne");
				prep2.setInt(1, idExecCampagne);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				stmtRes2.first();
				int idCampagne= stmtRes2.getInt("CAMPAGNE_TEST_id_camp");
				location = stmtRes2.getString("nom_exec_camp");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomCampagne");
				prep2.setInt(1, idCampagne);
				prep2.setInt(2, projetID);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				if(stmtRes2.first()){
					location = stmtRes2.getString("nom_camp") + fs + location;
					location = repertoireStockage + fs + location;
					prep2 = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement");
					prep2.setInt(1, stmtRes.getInt("ATTACHEMENT_id_attach"));
					stmtRes2 = SQLWrapper.runSelectQuery(prep2);
					if (stmtRes2.first()) {
						stmtRes2.first();
						vecteurRequirement.add(Integer.toString(stmtRes.getInt("ATTACHEMENT_id_attach")));
						vecteurRequirement.add(location.replaceAll(" ","_"));
						vecteurRequirement.add(stmtRes2.getString("nom_attach"));
					}
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}
	}	

	/**
	 * Initalise la lste des pices jointes
	 * @param nomProjet
	 */
	public void initResExecCampagneArrayList(String nomProjet){	
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupAttachmentResExecCampagne");
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next()) {
				String location="";
				int idResExecCampagne= stmtRes.getInt("RES_EXEC_CAMP_id_res_exec_camp");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomResExecCampagne");
				prep2.setInt(1, idResExecCampagne);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				stmtRes2.first();
				location = stmtRes2.getString("nom_res_exec_camp");
				int idExecCampagne= stmtRes2.getInt("EXEC_CAMP_id_exec_camp");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomExecCampagne");
				prep2.setInt(1, idExecCampagne);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				stmtRes2.first();
				int idCampagne= stmtRes2.getInt("CAMPAGNE_TEST_id_camp");
				location = stmtRes2.getString("nom_exec_camp")+ fs + location;
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomCampagne");
				prep2.setInt(1, idCampagne);
				prep2.setInt(2, projetID);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				if(stmtRes2.first()){
					location = stmtRes2.getString("nom_camp") + fs + location;
					location = repertoireStockage + fs + location;
					prep2 = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement");
					prep2.setInt(1, stmtRes.getInt("ATTACHEMENT_id_attach"));
					stmtRes2 = SQLWrapper.runSelectQuery(prep2);
					if (stmtRes2.first()) {
						stmtRes2.first();
						vecteurRequirement.add(Integer.toString(stmtRes.getInt("ATTACHEMENT_id_attach")));
						vecteurRequirement.add(location.replaceAll(" ","_"));
						vecteurRequirement.add(stmtRes2.getString("nom_attach"));
					}
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}
	}	

	/**
	 * Initalise la lste des pices jointes
	 * @param nomProjet
	 */
	public void initScriptsArrayList(String nomProjet){	
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupAttachmentScripts");
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next()) {
				String location="";
				int idScript= stmtRes.getInt("SCRIPT_id_script");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomScriptTest");
				prep2.setInt(1, idScript);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				stmtRes2.first();
				location = stmtRes2.getString("nom_cas");
				int idSuite= stmtRes2.getInt("SUITE_TEST_id_suite");
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomSuite");
				prep2.setInt(1, idSuite);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				stmtRes2.first();
				int idFamille = stmtRes2.getInt("FAMILLE_TEST_id_famille");
				location = stmtRes2.getString("nom_suite") + fs + location;
				prep2 = SQLWrapper.getSQLCommonQuery("recupNomFamille");
				prep2.setInt(1, idFamille);
				prep2.setInt(2, projetID);
				stmtRes2 = SQLWrapper.runSelectQuery(prep2);
				if(stmtRes2.first()){
					location = stmtRes2.getString("nom_famille") + fs + location ;
					location = repertoireStockage + fs + "Plan de tests" + fs + location;
					prep2 = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement");
					prep2.setInt(1, stmtRes.getInt("ATTACHEMENT_id_attach"));
					stmtRes2 = SQLWrapper.runSelectQuery(prep2);
					if (stmtRes2.first()) {
						stmtRes2.first();
						vecteurRequirement.add(Integer.toString(stmtRes.getInt("ATTACHEMENT_id_attach")));
						vecteurRequirement.add(location.replaceAll(" ","_"));
						vecteurRequirement.add(stmtRes2.getString("nom_attach"));
					}
				}
			}
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}
	}	

	/**
	 * Initalise la lste des pices jointes
	 * @param nomProjet
	 */
	public void initArrayList(String nomProjet){	
		//Recupre ID Projet
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupIDProjet");
			prep.setString(1, nomProjet);
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next()) {
				projetID = stmtRes.getInt("id_projet");
			}	
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_recuperation_Nom_Projet") + projetID,
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}

		//Recupre Campagnes Projet
		try {
			prep = SQLWrapper.getSQLCommonQuery("recupCampagnesProjet");
			prep.setInt(1, projetID);
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next()) {
				vecteurCampagneTest.add(Integer.toString(stmtRes.getInt("id_camp")));
				vecteurCampagneTest.add(stmtRes.getString("nom_camp"));
				vecteurCampagneTest.add(Integer.toString(stmtRes.getInt("PROJET_VOICE_TESTING_id_projet")));
			}	
		}catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
					Language.getInstance().getText("Probleme"),
					JOptionPane.WARNING_MESSAGE);
		}

		//Recupre Execution campagnes 
		for (int i = 0; i < vecteurCampagneTest.size(); i += 3) {
			try {
				prep = SQLWrapper.getSQLCommonQuery("recupExecCampagnesProjet");
				prep.setString(1, vecteurCampagneTest.get(i).toString());
				stmtRes = SQLWrapper.runSelectQuery(prep);
				while  (stmtRes.next()) {
					vecteurExecCampagne.add(Integer.toString(stmtRes.getInt("id_exec_camp")));
					vecteurExecCampagne.add(stmtRes.getString("nom_exec_camp"));
					vecteurExecCampagne.add(Integer.toString(stmtRes.getInt("CAMPAGNE_TEST_id_camp")));
				}	
			}catch (Exception e) {
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
						Language.getInstance().getText("Probleme"),
						JOptionPane.WARNING_MESSAGE);
			}
		}

		//Recupre Execution campagnes 
		for (int i = 0; i < vecteurExecCampagne.size(); i += 3) {
			try {
				prep = SQLWrapper.getSQLCommonQuery("recupResExecCampagnesProjet");
				prep.setString(1, vecteurExecCampagne.get(i).toString());
				stmtRes = SQLWrapper.runSelectQuery(prep);
				while  (stmtRes.next()) {
					vecteurResExecCampagne.add(Integer.toString(stmtRes.getInt("id_res_exec_camp")));
					vecteurResExecCampagne.add(stmtRes.getString("nom_res_exec_camp"));
					vecteurResExecCampagne.add(Integer.toString(stmtRes.getInt("EXEC_CAMP_id_exec_camp")));
				}	
			}catch (Exception e) {
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
						Language.getInstance().getText("Probleme"),
						JOptionPane.WARNING_MESSAGE);
			}
		}
		//Recupre cas d'execution campagnes 
		for (int i = 0; i < vecteurResExecCampagne.size(); i += 3) {
			try {
				prep = SQLWrapper.getSQLCommonQuery("recupExecCas");
				prep.setString(1, vecteurResExecCampagne.get(i).toString());
				stmtRes = SQLWrapper.runSelectQuery(prep);
				while  (stmtRes.next()) {
					vecteurExecCas.add(Integer.toString(stmtRes.getInt("id_exec_cas")));
					vecteurExecCas.add(stmtRes.getString("CAS_TEST_id_cas"));
					vecteurExecCas.add(Integer.toString(stmtRes.getInt("RES_EXEC_CAMP_id_res_exec_camp")));
				}	
			}catch (Exception e) {
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
						Language.getInstance().getText("Probleme"),
						JOptionPane.WARNING_MESSAGE);
			}
		}

		//Recupre Attachments cas d'execution campagnes 
		for (int i = 0; i < vecteurExecCas.size(); i += 3) {
			try {
				prep = SQLWrapper.getSQLCommonQuery("recupAttachmentsExecCas");
				prep.setString(1, vecteurExecCas.get(i).toString());
				stmtRes = SQLWrapper.runSelectQuery(prep);
				while  (stmtRes.next()) {
					prep2 = SQLWrapper.getSQLCommonQuery("recupDescriptionAttachement2");
					prep2.setInt(1, stmtRes.getInt("ATTACHEMENT_id_attach"));
					stmtRes2 = SQLWrapper.runSelectQuery(prep2);
					stmtRes2.first();
					if (stmtRes2.getString("description_attach").equals(Language.getInstance().getText("[MANTIS_ATTACH]"))){
						vecteurAttachmentMantisExecCas.add(Integer.toString(stmtRes.getInt("ATTACHEMENT_id_attach")));
						vecteurAttachmentMantisExecCas.add(stmtRes2.getString("description_attach"));
						vecteurAttachmentMantisExecCas.add(Integer.toString(stmtRes.getInt("EXEC_CAS_id_exec_cas")));
					}else if (!stmtRes2.getString("description_attach").equals("[URL_ATTACH]")) { 		
						vecteurAttachmentExecCas.add(Integer.toString(stmtRes.getInt("ATTACHEMENT_id_attach")));
						vecteurAttachmentExecCas.add(stmtRes2.getString("description_attach"));
						vecteurAttachmentExecCas.add(Integer.toString(stmtRes.getInt("EXEC_CAS_id_exec_cas")));
					}

				}	
			}catch (Exception e) {
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_SQL") + e.getMessage(),
						Language.getInstance().getText("Probleme"),
						JOptionPane.WARNING_MESSAGE);
			}
		}
	}

	/**
	 * @return boolean
	 */
	public boolean isConnexionMantisOK() {
		return ConnexionMantisOK;
	}

	/**
	 * @param connexionMantisOK
	 */
	public void setConnexionMantisOK(boolean connexionMantisOK) {
		ConnexionMantisOK = connexionMantisOK;
	}

	/**
	 * Vrification de la version de la table SQL
	 */
	public void verifieVersionTableSQL(){
	try {
		prep = SQLWrapper.getSQLCommonQuery("selectTableconfig_extract_attachement");
		stmtRes = SQLWrapper.runSelectQuery(prep);
	
		if (stmtRes.findColumn("Salome_EXTRACT_ATTACHMENT_MODE")== 2){
			System.out.println("table  jour");
		} else {
			System.out.println("MAJ TABLE");
			prep = SQLWrapper.getSQLCommonQuery("dropconfig_extract_attachement");
			SQLWrapper.runDeleteQuery(prep);
			//Cre la  table SQL
			prep = SQLWrapper.getSQLCommonQuery("creeconfig_extract_attachement");
			SQLWrapper.runUpdateQuery(prep);
		}
					
	} catch (Exception e) {
		SalomeTMFContext.getInstance().showMessage(
				Language.getInstance().getText("Erreur_MAJ_BDD"),
				Language.getInstance().getText("Probleme_config"),
				JOptionPane.WARNING_MESSAGE);
		DetachAttachment.this.dispose();
	} 
}
	
	
}