/*
 * SalomeTMF is a Test Management Framework
 * Copyright (C) 2007 EDF / France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * @author Jrmie DEFAYE
 *
 * Contact: mikael.marche@rd.francetelecom.com
 */

package salomeTMF_plug.ExtractAttachments;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

import javax.crypto.spec.SecretKeySpec;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import org.objectweb.salome_tmf.ihm.main.SalomeTMFContext;
import org.objectweb.salome_tmf.ihm.main.datawrapper.DataModel;
import org.objectweb.salome_tmf.plugins.IPlugObject;

import salomeTMF_plug.ExtractAttachments.DetachAttachment;
import salomeTMF_plug.ExtractAttachments.language.Language;
import salomeTMF_plug.ExtractAttachments.sqlWrapper.SQLWrapper;

import org.objectweb.salome_tmf.api.Util;
import org.objectweb.salome_tmf.data.Project;

import com.enterprisedt.net.ftp.FTPClient;
import com.enterprisedt.net.ftp.FTPException;
import com.enterprisedt.net.ftp.FTPMessageCollector;
import java.awt.Dimension;

/**
 * Fonction permettant de saisir et valider les mthodes d'extraction de SalomTMF 
 * et d'insertion dans Mantis des pices jointes
 */
public class FenetreSaisieConfig extends JDialog {
	
    /**
     * Variable d'Interface Homme Machine
     */
	private IPlugObject pIhm;
    /**
     * URL de SalomeTMF
     */
	private URL urlBase;
    /**
     * Url de SalomTMF au format texte
     */
	private String urlTexte;
    /**
     * Bouton valider
     */
	private JButton valider;
    /**
     * Bouton Annuler
     */
	private JButton annuler;
    /**
     * Prparateur d'execution de requtes SQL
     */
	private PreparedStatement prep;  //  @jve:decl-index=0:
    /**
     * Execution de requtes SQL
     */
	private ResultSet stmtRes;
    /**
     * Labal d'export SalomeTMF
     */
	private JLabel exportSalomeLabel;
    /**
     * RadioBouton export Fichier SalomTMF
     */
	private JRadioButton exportSalomeFile;
    /**
     * Label export Fichier SalomTMF
     */
	private JLabel exportSalomeFileLabel;
    /**
     * RadioBouton export FTP SalomTMF
     */
	private JRadioButton exportSalomeFTP;
    /**
     * Label export FTP SalomTMF
     */
	private JLabel exportSalomeFTPLabel;
    /**
     * Groupe de bouton radio pour l'export de SalomTMF
     */
	private ButtonGroup buttonGroupExportSalome;
    /**
     * Label texte
     */
	private JLabel exportSalomeRepertoireLabel;
    /**
     * Boite de saisie de Texte
     */
	private JTextField exportSalomeRepertoireTextbox;
    /**
     * Label texte
     */
	private JLabel exportSalomeFTPServeurLabel;
    /**
     * Boite de saisie de Texte
     */
	private JTextField exportSalomeFTPServeurTextbox;
    /**
     * Label texte
     */
	private JLabel exportSalomeFTPLoginLabel;
    /**
     * Boite de saisie de Texte
     */
	private JTextField exportSalomeFTPLoginTextbox;
    /**
     * Label texte
     */
	private JLabel exportSalomeFTPPasswordLabel;
    /**
     * Boite de saisie de Texte crypt
     */
	private JTextField exportSalomeFTPPasswordTextbox;
    /**
     * Label texte
     */
	private JLabel exportSalomeFTPDirectoryLabel;
    /**
     * Boite de saisie de Texte
     */
	private JTextField exportSalomeFTPDirectoryTextbox;
    /**
     * Label Import Mantis
     */
	private JLabel importMantisLabel;
    /**
     * RadioBouton Inport Fichier Mantis
     */
	private JRadioButton importMantisFile;
    /**
     * Label Import Fichier Mantis
     */
	private JLabel importMantisFileLabel;
    /**
     * RadioBouton export FTP Mantis
     */
	private JRadioButton importMantisFTP;
    /**
     * Label Import FTP Mantis
     */
	private JLabel importMantisFTPLabel;
    /**
     * Groupe de bouton radio pour l'import vers Mantis
     */
	private ButtonGroup buttonGroupImportMantis;
    /**
     * Label texte
     */
	private JLabel importMantisRepertoireLabel;
    /**
     * Boite de saisie de Texte
     */
	private JTextField importMantisRepertoireTextbox;
    /**
     * RadioBouton import Base de donnes Mantis
     */
	private JRadioButton importMantisDataBase;
    /**
     * Label texte
     */
	private JLabel importMantisDataBaseLabel;
    /**
     * RadioBouton export Base de donnes SalomeTMF
     */
	private JRadioButton exportSalomeDataBase;
    /**
     * Label texte
     */
	private JLabel exportSalomeDataBaseLabel;
    /**
     * RadioBouton Sortie FTP mais lien HTTP
     */
	private JRadioButton sortieFTP_HTTP;
    /**
     * Label texte
     */
	private JLabel sortieFTP_HTTPLabel;
    /**
     * RadioBouton sortie FTP
     */
	private JRadioButton sortieFTP_FTP;
    /**
     * Label texte
     */
	private JLabel sortieFTP_FTPLabel;
    /**
     * Groupe de bouton radio pour l'import vers Mantis
     */
	private ButtonGroup buttonGroupSortieFTP;
    /**
     * Label texte
     */
	private JLabel exportSalomeFTPSortie;
    /**
     * Label texte
     */
	private JLabel importMantisFTPServeurLabel;
    /**
     * Boite de saisie de Texte
     */
	private JTextField importMantisFTPServeurTextbox;
    /**
     * Label texte
     */
	private JLabel importMantisFTPLoginLabel;
    /**
     * Boite de saisie de Texte
     */
	private JTextField importMantisFTPLoginTextbox;
    /**
     * Label texte
     */
	private JLabel importMantisFTPPasswordLabel;
    /**
     * Boite de saisie de Texte
     */
	private JTextField importMantisFTPPasswordTextbox;
    /**
     * Label texte
     */
	private JLabel importMantisFTPDirectoryLabel;
    /**
     * Boite de saisie de Texte
     */
	private JTextField importMantisFTPDirectoryTextbox;
    /**
     * Label texte
     */
	private JLabel importMantisFTPSortie;
    /**
     * RadioBouton Sortie FTP
     */
	private JRadioButton sortieMantisFTP_FTP;
    /**
     * Label texte
     */
	private JLabel sortieMantisFTP_FTPLabel;
    /**
     * Groupe de bouton radio pour l'import vers Mantis
     */
	private ButtonGroup buttonMantisGroupSortieFTP;
	 boolean parametrageMantisOK;
    /**
     * Cl de cryptage
     */
	 private String cle = "melosajd";
	private int projetID;
	private Project proj;

    /**
     * Permet de saisir la configuration pour l'extration et l'insertion des pices jointes dans MAntis et SalomTMF
     * @param owner Fenetre modale sur le plugin d'extraction d'attazchement
     * @param vt Perent de remdre le programme plugable  SalomeTMF
     * @param ConnexionMantisOK booelan
     * @throws java.lang.Exception Gestion Exception
     */
	public FenetreSaisieConfig(Frame owner, IPlugObject vt, boolean ConnexionMantisOK) throws Exception {
		super(owner, true);
		initialize();
		//inistialisation
		pIhm= vt;
		urlBase = SalomeTMFContext.getInstance().getUrlBase();
		String _urlBase = urlBase.toString();
		urlTexte = _urlBase.substring(0, _urlBase.lastIndexOf("/"));
		proj = DataModel.getCurrentProject();
		
			
		//gestion des boutons
		valider = new JButton(Language.getInstance().getText("Valider"));
		valider.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
					EcritInfosDansBDD();
				}
		});

		annuler = new JButton(Language.getInstance().getText("Annuler"));
		annuler.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				FenetreSaisieConfig.this.dispose();
			}
		});
		boolean trouve = false;
		try {
			prep = SQLWrapper.getSQLCommonQuery("showTable");
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next() && !trouve) {
				String tableName = stmtRes.getString(1);
				if (tableName.equalsIgnoreCase(Language.getInstance().getText("config_extract_attachement"))){
					trouve = true;
				} 
			}	
			if (!trouve){
			//Cre la  table SQL
				prep = SQLWrapper.getSQLCommonQuery("creeconfig_extract_attachement");
				SQLWrapper.runUpdateQuery(prep);
			}
		} catch (Exception e) {
				SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_acces_BDD"),
					Language.getInstance().getText("Probleme_config"),
					JOptionPane.WARNING_MESSAGE);
			FenetreSaisieConfig.this.dispose();
		} 
		
	exportSalomeLabel = new JLabel(Language.getInstance().getText("Label_Export_Salome" ));	
	//	 Parte cration groupe icone
	exportSalomeDataBase = new JRadioButton();
	exportSalomeDataBaseLabel = new JLabel(Language.getInstance().getText("Database"));
	exportSalomeDataBase.setSelected(true);
	exportSalomeFile = new JRadioButton();
	exportSalomeFileLabel = new JLabel(Language.getInstance().getText("Network"));
	exportSalomeFTP = new JRadioButton();
	exportSalomeFTPLabel = new JLabel(Language.getInstance().getText("FTP"));
	buttonGroupExportSalome = new ButtonGroup();
	buttonGroupExportSalome.add(exportSalomeDataBase);
	buttonGroupExportSalome.add(exportSalomeFile);
	buttonGroupExportSalome.add(exportSalomeFTP);
	
	exportSalomeRepertoireLabel = new JLabel(Language.getInstance().getText("Label_Export_Salome_Repertoire"));	
	exportSalomeRepertoireTextbox = new JTextField(10);
	exportSalomeRepertoireLabel.setEnabled(false);
	exportSalomeRepertoireTextbox.setEnabled(false);
	
	exportSalomeFTPServeurLabel = new JLabel(Language.getInstance().getText("Label_Export_Salome_FTP_Serveur"));	
	exportSalomeFTPServeurTextbox = new JTextField(10);
	exportSalomeFTPLoginLabel = new JLabel(Language.getInstance().getText("Label_Export_Salome_FTP_Login"));	
	exportSalomeFTPLoginTextbox = new JTextField(10);
	exportSalomeFTPPasswordLabel = new JLabel(Language.getInstance().getText("Label_Export_Salome_FTP_Password"));	
	exportSalomeFTPPasswordTextbox = new JPasswordField(10);
	exportSalomeFTPDirectoryLabel = new JLabel(Language.getInstance().getText("Label_Export_Salome_FTP_Directory"));	
	exportSalomeFTPDirectoryTextbox = new JTextField(10);
	exportSalomeFTPServeurTextbox.setEnabled(false);
	exportSalomeFTPLoginTextbox.setEnabled(false);
	exportSalomeFTPPasswordTextbox.setEnabled(false);
	exportSalomeFTPDirectoryTextbox.setEnabled(false);
	exportSalomeFTPServeurLabel.setEnabled(false);
	exportSalomeFTPLoginLabel.setEnabled(false);
	exportSalomeFTPPasswordLabel.setEnabled(false);
	exportSalomeFTPDirectoryLabel.setEnabled(false);
	exportSalomeFTPSortie = new JLabel(Language.getInstance().getText("Sortie"));
	exportSalomeFTPSortie.setEnabled(false);
	
	sortieFTP_HTTP = new JRadioButton();
	sortieFTP_HTTPLabel = new JLabel(Language.getInstance().getText("http2p") + Language.getInstance().getText("suite"));
	sortieFTP_FTP = new JRadioButton();
	sortieFTP_FTPLabel = new JLabel(Language.getInstance().getText("ftp2p")+ Language.getInstance().getText("suite"));
	buttonGroupSortieFTP = new ButtonGroup();
	buttonGroupSortieFTP.add(sortieFTP_HTTP);
	buttonGroupSortieFTP.add(sortieFTP_FTP);
	sortieFTP_HTTP.setEnabled(false);
	sortieFTP_FTP.setSelected(true);
	sortieFTP_FTP.setEnabled(false);
	
	importMantisFTPServeurLabel = new JLabel(Language.getInstance().getText("Label_Export_Salome_FTP_Serveur"));	
	importMantisFTPServeurTextbox = new JTextField(10);
	importMantisFTPLoginLabel = new JLabel(Language.getInstance().getText("Label_Export_Salome_FTP_Login"));	
	importMantisFTPLoginTextbox = new JTextField(10);
	importMantisFTPPasswordLabel = new JLabel(Language.getInstance().getText("Label_Export_Salome_FTP_Password"));	
	importMantisFTPPasswordTextbox = new JPasswordField(10);
	importMantisFTPDirectoryLabel = new JLabel(Language.getInstance().getText("Label_Export_Salome_FTP_Directory"));	
	importMantisFTPDirectoryTextbox = new JTextField(10);
	importMantisFTPServeurTextbox.setEnabled(false);
	importMantisFTPLoginTextbox.setEnabled(false);
	importMantisFTPPasswordTextbox.setEnabled(false);
	importMantisFTPDirectoryTextbox.setEnabled(false);
	importMantisFTPServeurLabel.setEnabled(false);
	importMantisFTPLoginLabel.setEnabled(false);
	importMantisFTPPasswordLabel.setEnabled(false);
	importMantisFTPDirectoryLabel.setEnabled(false);
	importMantisFTPSortie = new JLabel(Language.getInstance().getText("Sortie"));
	importMantisFTPSortie.setEnabled(false);
	
	sortieMantisFTP_FTP = new JRadioButton();
	sortieMantisFTP_FTPLabel = new JLabel(Language.getInstance().getText("ftp2p")+ Language.getInstance().getText("suite"));
	buttonMantisGroupSortieFTP = new ButtonGroup();
	buttonMantisGroupSortieFTP.add(sortieMantisFTP_FTP);
	sortieMantisFTP_FTP.setEnabled(false);
	sortieMantisFTP_FTP.setSelected(true);
	
	exportSalomeDataBase.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			exportSalomeRepertoireTextbox.setEnabled(false);
			exportSalomeRepertoireTextbox.setText("");
			exportSalomeRepertoireLabel.setEnabled(false);
			exportSalomeFTPServeurTextbox.setEnabled(false);
			exportSalomeFTPLoginTextbox.setEnabled(false);
			exportSalomeFTPPasswordTextbox.setEnabled(false);
			exportSalomeFTPDirectoryTextbox.setEnabled(false);
			exportSalomeFTPServeurLabel.setEnabled(false);
			exportSalomeFTPLoginLabel.setEnabled(false);
			exportSalomeFTPPasswordLabel.setEnabled(false);
			exportSalomeFTPDirectoryLabel.setEnabled(false);
			exportSalomeFTPServeurTextbox.setText("");
			exportSalomeFTPLoginTextbox.setText("");
			exportSalomeFTPPasswordTextbox.setText("");
			exportSalomeFTPDirectoryTextbox.setText("");
			sortieFTP_HTTP.setEnabled(false);
			sortieFTP_FTP.setEnabled(false);
			exportSalomeFTPSortie.setEnabled(false);
		}
	});
	exportSalomeFile.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			exportSalomeRepertoireTextbox.setEnabled(true);
			exportSalomeRepertoireTextbox.setText(Language.getInstance().getText("repFile"));
			exportSalomeRepertoireLabel.setEnabled(true);
			exportSalomeFTPServeurTextbox.setEnabled(false);
			exportSalomeFTPLoginTextbox.setEnabled(false);
			exportSalomeFTPPasswordTextbox.setEnabled(false);
			exportSalomeFTPDirectoryTextbox.setEnabled(false);
			exportSalomeFTPServeurLabel.setEnabled(false);
			exportSalomeFTPLoginLabel.setEnabled(false);
			exportSalomeFTPPasswordLabel.setEnabled(false);
			exportSalomeFTPDirectoryLabel.setEnabled(false);
			exportSalomeFTPServeurTextbox.setText("");
			exportSalomeFTPLoginTextbox.setText("");
			exportSalomeFTPPasswordTextbox.setText("");
			exportSalomeFTPDirectoryTextbox.setText("");
			sortieFTP_HTTP.setEnabled(false);
			sortieFTP_FTP.setEnabled(false);
			exportSalomeFTPSortie.setEnabled(false);
		}
	});
	
	exportSalomeFTP.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			exportSalomeRepertoireTextbox.setEnabled(false);
			exportSalomeRepertoireTextbox.setText("");
			exportSalomeRepertoireLabel.setEnabled(false);
			exportSalomeFTPServeurTextbox.setEnabled(true);
			exportSalomeFTPLoginTextbox.setEnabled(true);
			exportSalomeFTPPasswordTextbox.setEnabled(true);
			exportSalomeFTPDirectoryTextbox.setEnabled(true);
			exportSalomeFTPServeurLabel.setEnabled(true);
			exportSalomeFTPLoginLabel.setEnabled(true);
			exportSalomeFTPPasswordLabel.setEnabled(true);
			exportSalomeFTPDirectoryLabel.setEnabled(true);
			exportSalomeFTPServeurTextbox.setText(Language.getInstance().getText("serveur"));
			exportSalomeFTPLoginTextbox.setText(Language.getInstance().getText("anonymous"));
			exportSalomeFTPPasswordTextbox.setText(Language.getInstance().getText("anonymous_password"));
			exportSalomeFTPDirectoryTextbox.setText(Language.getInstance().getText("repFTP"));
			sortieFTP_HTTP.setEnabled(true);
			sortieFTP_FTP.setEnabled(true);
			exportSalomeFTPSortie.setEnabled(true);
		}
	});
	
	sortieFTP_HTTP.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("MessageCheminFTPIdemHTTP"),
					Language.getInstance().getText("Attention"),
					JOptionPane.WARNING_MESSAGE);
		}
	});
	
	importMantisLabel = new JLabel(Language.getInstance().getText("Label_Import_Mantis" ));	
	//	 Parte cration groupe icone
	importMantisDataBase = new JRadioButton();
	importMantisDataBaseLabel = new JLabel(Language.getInstance().getText("Database"));
	importMantisDataBase.setSelected(true);
	importMantisFile = new JRadioButton();
	importMantisFileLabel = new JLabel(Language.getInstance().getText("Network"));
	importMantisFTP = new JRadioButton();
	importMantisFTPLabel = new JLabel(Language.getInstance().getText("FTP"));
	buttonGroupImportMantis = new ButtonGroup();
	buttonGroupImportMantis.add(importMantisDataBase);
	buttonGroupImportMantis.add(importMantisFile);
	buttonGroupImportMantis.add(importMantisFTP);
	
	importMantisRepertoireLabel = new JLabel(Language.getInstance().getText("Label_Import_Mantis_Repertoire"));	
	importMantisRepertoireTextbox = new JTextField(10);
	importMantisRepertoireTextbox.setEnabled(false);
	importMantisRepertoireLabel.setEnabled(false);
	
	importMantisDataBase.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			importMantisRepertoireTextbox.setEnabled(false);
			importMantisRepertoireLabel.setEnabled(false);
			importMantisRepertoireTextbox.setText("");
			importMantisFTPServeurTextbox.setEnabled(false);
			importMantisFTPLoginTextbox.setEnabled(false);
			importMantisFTPPasswordTextbox.setEnabled(false);
			importMantisFTPDirectoryTextbox.setEnabled(false);
			importMantisFTPServeurLabel.setEnabled(false);
			importMantisFTPLoginLabel.setEnabled(false);
			importMantisFTPPasswordLabel.setEnabled(false);
			importMantisFTPDirectoryLabel.setEnabled(false);
			importMantisFTPServeurTextbox.setText("");
			importMantisFTPLoginTextbox.setText("");
			importMantisFTPPasswordTextbox.setText("");
			importMantisFTPDirectoryTextbox.setText("");
			sortieMantisFTP_FTP.setEnabled(false);
			importMantisFTPSortie.setEnabled(false);
			}
	});
	
	importMantisFile.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			importMantisRepertoireTextbox.setEnabled(true);
			importMantisRepertoireLabel.setEnabled(true);
			importMantisRepertoireTextbox.setText(Language.getInstance().getText("repFileLocal"));
			importMantisFTPServeurTextbox.setEnabled(false);
			importMantisFTPLoginTextbox.setEnabled(false);
			importMantisFTPPasswordTextbox.setEnabled(false);
			importMantisFTPDirectoryTextbox.setEnabled(false);
			importMantisFTPServeurLabel.setEnabled(false);
			importMantisFTPLoginLabel.setEnabled(false);
			importMantisFTPPasswordLabel.setEnabled(false);
			importMantisFTPDirectoryLabel.setEnabled(false);
			importMantisFTPServeurTextbox.setText("");
			importMantisFTPLoginTextbox.setText("");
			importMantisFTPPasswordTextbox.setText("");
			importMantisFTPDirectoryTextbox.setText("");
			sortieMantisFTP_FTP.setEnabled(false);
			importMantisFTPSortie.setEnabled(false);
			}
	});
	
	importMantisFTP.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			importMantisRepertoireTextbox.setEnabled(false);
			importMantisRepertoireLabel.setEnabled(false);
			importMantisRepertoireTextbox.setText("");
			importMantisFTPServeurTextbox.setEnabled(true);
			importMantisFTPLoginTextbox.setEnabled(true);
			importMantisFTPPasswordTextbox.setEnabled(true);
			importMantisFTPDirectoryTextbox.setEnabled(true);
			importMantisFTPServeurLabel.setEnabled(true);
			importMantisFTPLoginLabel.setEnabled(true);
			importMantisFTPPasswordLabel.setEnabled(true);
			importMantisFTPDirectoryLabel.setEnabled(true);
			importMantisFTPServeurTextbox.setText(Language.getInstance().getText("serveur"));
			importMantisFTPLoginTextbox.setText(Language.getInstance().getText("anonymous"));
			importMantisFTPPasswordTextbox.setText(Language.getInstance().getText("anonymous_password"));
			importMantisFTPDirectoryTextbox.setText(Language.getInstance().getText("repFTP"));
			sortieMantisFTP_FTP.setEnabled(true);
			importMantisFTPSortie.setEnabled(true);
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Messagedownloadfilephp"),
					Language.getInstance().getText("Attention"),
					JOptionPane.WARNING_MESSAGE);
			}
	});
	
	
	if(trouve){	
	try {
prep = SQLWrapper.getSQLCommonQuery("selectconfig_extract_attachement");
prep.setInt(1, projetID);
stmtRes = SQLWrapper.runSelectQuery(prep);
if (stmtRes.next()){
	
	if(stmtRes.getString("Salome_EXTRACT_ATTACHMENT_MODE").equals(Language.getInstance().getText("DB"))){
				setExportSalomeDataBase();
	}else if(stmtRes.getString("Salome_EXTRACT_ATTACHMENT_MODE").equals(Language.getInstance().getText("File"))){
		setExportSalomeFile();
		exportSalomeRepertoireTextbox.setEnabled(true);
	}else if(stmtRes.getString("Salome_EXTRACT_ATTACHMENT_MODE").equals(Language.getInstance().getText("FTP"))){
		setExportSalomeFTP();
		exportSalomeFTPServeurTextbox.setEnabled(true);
		exportSalomeFTPLoginTextbox.setEnabled(true);
		exportSalomeFTPPasswordTextbox.setEnabled(true);
		exportSalomeFTPDirectoryTextbox.setEnabled(true);
		exportSalomeFTPServeurLabel.setEnabled(true);
		exportSalomeFTPLoginLabel.setEnabled(true);
		exportSalomeFTPPasswordLabel.setEnabled(true);
		exportSalomeFTPDirectoryLabel.setEnabled(true);
		sortieFTP_HTTP.setEnabled(true);
		sortieFTP_FTP.setEnabled(true);
		exportSalomeFTPSortie.setEnabled(true);
	}else {
		setExportSalomeDataBase();
	}
	
	setExportSalomeRepertoireTextbox(stmtRes.getString("Salome_Network_RELATIVE_PATH"));
	setExportSalomeFTPServeurTextbox(stmtRes.getString("Salome_FTP_SERVER"));
	setExportSalomeFTPLoginTextbox(stmtRes.getString("Salome_FTP_LOGIN"));
	URL urlSalome = new URL(urlTexte);
	try {
		urlSalome.openStream();
		MD5paswd.readkey(urlSalome);
	}catch (Exception e) {
		String cle = "melosajd";
		MD5paswd.key = new SecretKeySpec(cle.getBytes() , "DES");
	}
	setExportSalomeFTPPasswordTextbox(MD5paswd.decryptString(stmtRes.getString("Salome_FTP_PASSWORD")));
	setExportSalomeFTPDirectoryTextbox(stmtRes.getString("Salome_FTP_DIRECTORY"));
		
	if(stmtRes.getString("Salome_FTP_SORTIE").equals(Language.getInstance().getText("ftp2p"))){
		setSortieFTP_FTP();
		}else if(stmtRes.getString("Salome_FTP_SORTIE").equals(Language.getInstance().getText("http2p"))){
		setSortieFTP_HTTP();
		} else {	
			setSortieFTP_HTTP();
	}
	
	if(stmtRes.getString("MANTIS_INSERT").equals(Language.getInstance().getText("DB"))){
		setImportMantisDataBase();
	}else if(stmtRes.getString("MANTIS_INSERT").equals(Language.getInstance().getText("File"))){
		setImportMantisFile();
		importMantisRepertoireTextbox.setEnabled(true);
	}else if(stmtRes.getString("MANTIS_INSERT").equals(Language.getInstance().getText("FTP"))){
		setImportMantisFTP();
		importMantisFTPServeurTextbox.setEnabled(true);
		importMantisFTPLoginTextbox.setEnabled(true);
		importMantisFTPPasswordTextbox.setEnabled(true);
		importMantisFTPDirectoryTextbox.setEnabled(true);
		importMantisFTPServeurLabel.setEnabled(true);
		importMantisFTPLoginLabel.setEnabled(true);
		importMantisFTPPasswordLabel.setEnabled(true);
		importMantisFTPDirectoryLabel.setEnabled(true);
		sortieMantisFTP_FTP.setEnabled(true);
		importMantisFTPSortie.setEnabled(true);
	}else {
		setImportMantisDataBase();
	}
	setImportMantisRepertoireTextbox(stmtRes.getString("MANTIS_Network_RELATIVE_PATH"));
	setImportMantisFTPServeurTextbox(stmtRes.getString("MANTIS_FTP_SERVER"));
	setImportMantisFTPLoginTextbox(stmtRes.getString("MANTIS_FTP_LOGIN"));
	try {
		urlSalome.openStream();
		MD5paswd.readkey(urlSalome);
	}catch (Exception e) {
		MD5paswd.key = new SecretKeySpec(cle.getBytes() , "DES");
	}
	setImportMantisFTPPasswordTextbox(MD5paswd.decryptString(stmtRes.getString("MANTIS_FTP_PASSWORD")));
	setImportMantisFTPDirectoryTextbox(stmtRes.getString("MANTIS_FTP_DIRECTORY"));
	
}
} catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_acces_BDD"),
					Language.getInstance().getText("Probleme_config"),
					JOptionPane.WARNING_MESSAGE);
	//		FenetreSaisieConfig.this.dispose();
		} 
	}
	
	
	
	JPanel exportSalomePanel = new JPanel();
	exportSalomePanel.setLayout(new FlowLayout(FlowLayout.CENTER));
	exportSalomePanel.add(exportSalomeLabel);
	
	JPanel selectexportSalomePanel = new JPanel();
	selectexportSalomePanel.setLayout(new BoxLayout(selectexportSalomePanel, BoxLayout.Y_AXIS));
	selectexportSalomePanel.setBorder(BorderFactory.createTitledBorder(""));
	selectexportSalomePanel.add(exportSalomePanel);
	
	
	JPanel exportTypeSalomePanel = new JPanel();
	exportTypeSalomePanel.setLayout(new FlowLayout(FlowLayout.CENTER));
	exportTypeSalomePanel.add(exportSalomeDataBase);
	exportTypeSalomePanel.add(exportSalomeDataBaseLabel);
	exportTypeSalomePanel.add(exportSalomeFile);
	exportTypeSalomePanel.add(exportSalomeFileLabel);
	exportTypeSalomePanel.add(exportSalomeFTP);
	exportTypeSalomePanel.add(exportSalomeFTPLabel);
	
	JPanel selectexportTypeSalomePanel = new JPanel();
	selectexportTypeSalomePanel.setLayout(new BoxLayout(selectexportTypeSalomePanel, BoxLayout.Y_AXIS));
	selectexportTypeSalomePanel.setBorder(BorderFactory.createTitledBorder(""));
	selectexportTypeSalomePanel.add(exportTypeSalomePanel);
	
	JPanel exportSalomeRepertoirePanel = new JPanel();
	exportSalomeRepertoirePanel.setLayout(new GridLayout(1,2));
	exportSalomeRepertoirePanel.add(exportSalomeRepertoireLabel);
	exportSalomeRepertoirePanel.add(exportSalomeRepertoireTextbox);
	
	JPanel selectexportSalomeRepertoirePanel = new JPanel();
	selectexportSalomeRepertoirePanel.setLayout(new BoxLayout(selectexportSalomeRepertoirePanel, BoxLayout.Y_AXIS));
	selectexportSalomeRepertoirePanel.setBorder(BorderFactory.createTitledBorder(""));
	selectexportSalomeRepertoirePanel.add(exportSalomeRepertoirePanel);
	
	JPanel FTPSortie = new JPanel();
	FTPSortie.setLayout(new FlowLayout(FlowLayout.LEFT));
	FTPSortie.add(sortieFTP_HTTP);
	FTPSortie.add(sortieFTP_HTTPLabel);
	FTPSortie.add(sortieFTP_FTP);
	FTPSortie.add(sortieFTP_FTPLabel);
	
	JPanel FTPServeur = new JPanel();
	FTPServeur.setLayout(new GridLayout(5,2));
	FTPServeur.add(exportSalomeFTPServeurLabel);
	FTPServeur.add(exportSalomeFTPServeurTextbox);
	FTPServeur.add(exportSalomeFTPLoginLabel);
	FTPServeur.add(exportSalomeFTPLoginTextbox);
	FTPServeur.add(exportSalomeFTPPasswordLabel);
	FTPServeur.add(exportSalomeFTPPasswordTextbox);
	FTPServeur.add(exportSalomeFTPDirectoryLabel);
	FTPServeur.add(exportSalomeFTPDirectoryTextbox);
	FTPServeur.add(exportSalomeFTPSortie);
	FTPServeur.add(FTPSortie);
	         
     JPanel textFTPPanel = new JPanel();
     textFTPPanel.setLayout(new BoxLayout(textFTPPanel,BoxLayout.Y_AXIS));
     textFTPPanel.setBorder(BorderFactory.createTitledBorder(""));
     textFTPPanel.add(FTPServeur);
     JPanel MantisFTPSortie = new JPanel();
 	MantisFTPSortie.setLayout(new FlowLayout(FlowLayout.LEFT));
 	MantisFTPSortie.add(sortieMantisFTP_FTP);
 	MantisFTPSortie.add(sortieMantisFTP_FTPLabel);
 	
     JPanel MantisFTPServeur = new JPanel();
     MantisFTPServeur.setLayout(new GridLayout(5,2));
     MantisFTPServeur.add(importMantisFTPServeurLabel);
     MantisFTPServeur.add(importMantisFTPServeurTextbox);
     MantisFTPServeur.add(importMantisFTPLoginLabel);
     MantisFTPServeur.add(importMantisFTPLoginTextbox);
     MantisFTPServeur.add(importMantisFTPPasswordLabel);
     MantisFTPServeur.add(importMantisFTPPasswordTextbox);
     MantisFTPServeur.add(importMantisFTPDirectoryLabel);
     MantisFTPServeur.add(importMantisFTPDirectoryTextbox);
     MantisFTPServeur.add(importMantisFTPSortie);
 	 MantisFTPServeur.add(MantisFTPSortie);
 	         
 	
     JPanel MantisTextFTPPanel = new JPanel();
     MantisTextFTPPanel.setLayout(new BoxLayout(MantisTextFTPPanel,BoxLayout.Y_AXIS));
     MantisTextFTPPanel.setBorder(BorderFactory.createTitledBorder(""));
     MantisTextFTPPanel.add(MantisFTPServeur);
    
     
	 JPanel importMantisPanel = new JPanel();
	 importMantisPanel.setLayout(new FlowLayout(FlowLayout.CENTER));
	 importMantisPanel.add(importMantisLabel);
	 
 	JPanel selectimportMantisPanel = new JPanel();
 	selectimportMantisPanel.setLayout(new BoxLayout(selectimportMantisPanel, BoxLayout.Y_AXIS));
 	selectimportMantisPanel.setBorder(BorderFactory.createTitledBorder(""));
 	selectimportMantisPanel.add(importMantisPanel);
 	
 	JPanel importTypeMantisPanel = new JPanel();
 	importTypeMantisPanel.setLayout(new FlowLayout(FlowLayout.CENTER));
 	importTypeMantisPanel.add(importMantisDataBase);
 	importTypeMantisPanel.add(importMantisDataBaseLabel);
 	importTypeMantisPanel.add(importMantisFile);
 	importTypeMantisPanel.add(importMantisFileLabel);
 	importTypeMantisPanel.add(importMantisFTP);
 	importTypeMantisPanel.add(importMantisFTPLabel);
	
	JPanel selectTypeimportMantisPanel = new JPanel();
	selectTypeimportMantisPanel.setLayout(new BoxLayout(selectTypeimportMantisPanel, BoxLayout.Y_AXIS));
	selectTypeimportMantisPanel.setBorder(BorderFactory.createTitledBorder(""));
	selectTypeimportMantisPanel.add(importTypeMantisPanel);
	
	
	JPanel importMantisRepertoirePanel = new JPanel();
 	importMantisRepertoirePanel.setLayout(new GridLayout(1,2));
 	importMantisRepertoirePanel.add(importMantisRepertoireLabel);
 	importMantisRepertoirePanel.add(importMantisRepertoireTextbox);
 	
 	JPanel selectImportMantisRepertoirePanel = new JPanel();
 	selectImportMantisRepertoirePanel.setLayout(new BoxLayout(selectImportMantisRepertoirePanel, BoxLayout.Y_AXIS));
 	selectImportMantisRepertoirePanel.setBorder(BorderFactory.createTitledBorder(""));
 	selectImportMantisRepertoirePanel.add(importMantisRepertoirePanel);
     
  	JPanel buttons = new JPanel();
	buttons.add(valider);
	buttons.add(annuler);

	JPanel page = new JPanel();
	page.setLayout(new GridBagLayout());
	Insets insets = new Insets(4,4,4,4);
	page.add(selectexportSalomePanel,new GridBagConstraints(0,0,1,1,100,100,GridBagConstraints.CENTER,GridBagConstraints.BOTH,insets,0,0));
	if (ConnexionMantisOK){
	page.add(selectimportMantisPanel,new GridBagConstraints(1,0,1,1,100,100,GridBagConstraints.CENTER,GridBagConstraints.BOTH,insets,0,0));
	page.add(selectTypeimportMantisPanel,new GridBagConstraints(1,1,1,1,100,100,GridBagConstraints.CENTER,GridBagConstraints.BOTH,insets,0,0));
	page.add(selectImportMantisRepertoirePanel,new GridBagConstraints(1,2,1,1,100,100,GridBagConstraints.CENTER,GridBagConstraints.BOTH,insets,0,0));
	page.add(MantisTextFTPPanel,new GridBagConstraints(1,3,1,1,100,100,GridBagConstraints.CENTER,GridBagConstraints.BOTH,insets,0,0));
	}
	page.add(selectexportTypeSalomePanel,new GridBagConstraints(0,1,1,1,100,100,GridBagConstraints.CENTER,GridBagConstraints.BOTH,insets,0,0));
	page.add(selectexportSalomeRepertoirePanel,new GridBagConstraints(0,2,1,1,100,100,GridBagConstraints.CENTER,GridBagConstraints.BOTH,insets,0,0));
	page.add(textFTPPanel,new GridBagConstraints(0,3,1,1,100,100,GridBagConstraints.CENTER,GridBagConstraints.BOTH,insets,0,0));
	page.add(buttons,new GridBagConstraints(0,4,2,1,100,100,GridBagConstraints.CENTER,GridBagConstraints.BOTH,insets,0,0));
	
	Container contentPaneFrame = this.getContentPane();
	contentPaneFrame.add(page, BorderLayout.CENTER);
	setLocation(400, 100);
	setTitle(Language.getInstance().getText("Extraction_Configuration"));
	centerScreen();
	}

protected void centerScreen() {
	Dimension dim = getToolkit().getScreenSize();
	this.pack();
	Rectangle abounds = getBounds();
	setLocation((dim.width - abounds.width) / 2, (dim.height - abounds.height) / 2);	 
	this.setVisible(true); 
	requestFocus();
}
	
	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
        this.setSize(new Dimension(295, 168));
			
	}

    /**
     * Ecrit les paramtres du plugin dans la base de donnes de SalomTMF
     */
	public void EcritInfosDansBDD(){
		boolean parametrageSalomeOK=false;
		
		//		Cree table si elle existe pas 
		boolean trouve= false;
		
		try {
			prep = SQLWrapper.getSQLCommonQuery("showTable");
			stmtRes = SQLWrapper.runSelectQuery(prep);
			while  (stmtRes.next() && !trouve) {
				String tableName = stmtRes.getString(1);
				if (tableName.equalsIgnoreCase(Language.getInstance().getText("config_extract_attachement"))){
					//Rcupre dans Salom le nom du projet
					prep = SQLWrapper.getSQLCommonQuery("recupIDProjet");
					prep.setString(1, proj.getNameFromModel());
					stmtRes = SQLWrapper.runSelectQuery(prep);
					while  (stmtRes.next()) {
						projetID = stmtRes.getInt("id_projet");
					}	
					prep = SQLWrapper.getSQLCommonQuery("selectTableconfig_extract_attachement");
					stmtRes = SQLWrapper.runSelectQuery(prep);
					while  (stmtRes.next() && (trouve == false)) {
						if (stmtRes.getInt("Salome_PROJECT_ID") == projetID){
							trouve = true;
						}	
					}
				} 
			}	
		} catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_acces_BDD"),
					Language.getInstance().getText("Probleme_config"),
					JOptionPane.WARNING_MESSAGE);
	//		FenetreSaisieConfig.this.dispose();
		} 

		if (trouve==false){
			try {
			prep = SQLWrapper.getSQLCommonQuery("creeconfig_extract_attachement");
			SQLWrapper.runUpdateQuery(prep);
		} catch (Exception e) {
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Erreur_acces_BDD"),
					Language.getInstance().getText("Probleme_config"),
					JOptionPane.WARNING_MESSAGE);
//			FenetreSaisieConfig.this.dispose();
		} 
		}
		
		if(getExportSalomeDataBase()) {
			parametrageSalomeOK= true;
		}
		
		if(getExportSalomeFile()) {
			File f = new File(getExportSalomeRepertoireTextbox());
			if (f.exists()) {
				parametrageSalomeOK= true;
			}else {
				parametrageSalomeOK= false;
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_Parametrage_Repertoire"),
						Language.getInstance().getText("Probleme_config"),
						JOptionPane.WARNING_MESSAGE);
			}
			
		}
		
		if(getExportSalomeFTP()) {
			FTPClient ftp = new FTPClient();
		try {
			ftp.setRemoteHost(getExportSalomeFTPServeurTextbox());
			FTPMessageCollector listener = new FTPMessageCollector();
			ftp.setMessageListener(listener);
			ftp.connect();
			ftp.login(getExportSalomeFTPLoginTextbox(), getExportSalomeFTPPasswordTextbox());
			Util.log("[FTP] " + listener.getLog());
			ftp.quit();
			parametrageSalomeOK= true;
		} catch (FTPException e) {
			parametrageSalomeOK= false;
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Pb_Config_FTP"),
					Language.getInstance().getText("Probleme_config"),
					JOptionPane.WARNING_MESSAGE);
			} catch (IOException e) {
			parametrageSalomeOK= false;
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Pb_Config_FTP"),
					Language.getInstance().getText("Probleme_config"),
					JOptionPane.WARNING_MESSAGE);
			}
		}
		if(getImportMantisDataBase()) {
			parametrageMantisOK= true;
		}
		
		if(getImportMantisFile()) {
			if (getImportMantisRepertoireTextbox().startsWith("\\")||getImportMantisRepertoireTextbox().startsWith("//")){
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_Parametrage_Repertoire_Mantis_Reseau"),
						Language.getInstance().getText("Probleme_config"),
						JOptionPane.WARNING_MESSAGE);
				parametrageMantisOK= false;
			}else {
		
			File f = new File(getImportMantisRepertoireTextbox());
			if (f.exists()) {
				parametrageMantisOK= true;
			}else {
				parametrageMantisOK= false;
				SalomeTMFContext.getInstance().showMessage(
						Language.getInstance().getText("Erreur_Parametrage_Repertoire"),
						Language.getInstance().getText("Probleme_config"),
						JOptionPane.WARNING_MESSAGE);
			}
			}
		}
	
		
		if(getImportMantisFTP()) {
			FTPClient ftp = new FTPClient();
		try {
			ftp.setRemoteHost(getImportMantisFTPServeurTextbox());
			FTPMessageCollector listener = new FTPMessageCollector();
			ftp.setMessageListener(listener);
			ftp.connect();
			ftp.login(getImportMantisFTPLoginTextbox(), getImportMantisFTPPasswordTextbox());
			Util.log("[FTP] " + listener.getLog());
			ftp.quit();
			parametrageMantisOK= true;
		} catch (FTPException e) {
			parametrageMantisOK= false;
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Pb_Config_FTP"),
					Language.getInstance().getText("Probleme_config"),
					JOptionPane.WARNING_MESSAGE);
			} catch (IOException e) {
			parametrageMantisOK= false;
			SalomeTMFContext.getInstance().showMessage(
					Language.getInstance().getText("Pb_Config_FTP"),
					Language.getInstance().getText("Probleme_config"),
					JOptionPane.WARNING_MESSAGE);
			}
		}
	
		if (parametrageSalomeOK && parametrageMantisOK){
			
		try{
		//supprime config si dja presente
		prep = SQLWrapper.getSQLCommonQuery("selectconfig_extract_attachement");
		prep.setInt(1, projetID);
		stmtRes = SQLWrapper.runSelectQuery(prep);
		if (stmtRes.next()){
			prep = SQLWrapper.getSQLCommonQuery("deleteconfig_extract_attachement");
			prep.setInt(1, projetID);
			SQLWrapper.runDeleteQuery(prep);
		}
		} catch (Exception e) {
					SalomeTMFContext.getInstance().showMessage(
							Language.getInstance().getText("Erreur_acces_BDD"),
							Language.getInstance().getText("Probleme_config"),
							JOptionPane.WARNING_MESSAGE);
					FenetreSaisieConfig.this.dispose();
		} 
		
		try{
		prep = SQLWrapper.getSQLCommonQuery("insertconfig_extract_attachement");
		prep.setInt(1, projetID);
		if(getExportSalomeDataBase()){
			prep.setString(2, Language.getInstance().getText("DB"));
		}else if(getExportSalomeFile()){
			prep.setString(2, Language.getInstance().getText("File"));
		}else if(getExportSalomeFTP()){
			prep.setString(2, Language.getInstance().getText("FTP"));
		}else {
			prep.setString(2, Language.getInstance().getText("DB"));
		}
		
			
		prep.setString(3, getExportSalomeRepertoireTextbox());
		prep.setString(4, getExportSalomeFTPServeurTextbox());
		prep.setString(5, getExportSalomeFTPLoginTextbox());
		
		URL urlSalome = new URL(urlTexte);
		try {
			urlSalome.openStream();
			MD5paswd.readkey(urlSalome);
		}catch (Exception e) {
			MD5paswd.key = new SecretKeySpec(cle.getBytes() , "DES");
		}
		String mdpCrypte =MD5paswd.encrypString(getExportSalomeFTPPasswordTextbox());
		prep.setString(6, mdpCrypte);
		if (getExportSalomeFTPDirectoryTextbox().length()==0){
			setExportSalomeFTPDirectoryTextbox("/");
		}
		if(!getExportSalomeFTPDirectoryTextbox().startsWith("/")){
			setExportSalomeFTPDirectoryTextbox("/" + getExportSalomeFTPDirectoryTextbox());
		}
		if(!getExportSalomeFTPDirectoryTextbox().endsWith("/")){
			setExportSalomeFTPDirectoryTextbox(getExportSalomeFTPDirectoryTextbox() + "/");
		}
		prep.setString(7, getExportSalomeFTPDirectoryTextbox());
	
		if(getSortieFTP_FTP()){
			prep.setString(8, Language.getInstance().getText("ftp2p"));
		}else if(getSortieFTP_HTTP()){
			prep.setString(8, Language.getInstance().getText("http2p"));
		} else {	
		prep.setString(8, Language.getInstance().getText("http2p"));
		}
		
		if(getImportMantisDataBase()){
			prep.setString(9, Language.getInstance().getText("DB"));
		}else if(getImportMantisFile()){
			prep.setString(9, Language.getInstance().getText("File"));
		}else if(getImportMantisFTP()){
			prep.setString(9, Language.getInstance().getText("FTP"));
		}else {
			prep.setString(9, Language.getInstance().getText("DB"));
		}
	
		prep.setString(10, getImportMantisRepertoireTextbox());
		prep.setString(11, getImportMantisFTPServeurTextbox());
		prep.setString(12, getImportMantisFTPLoginTextbox());
		
		try {
			urlSalome.openStream();
			MD5paswd.readkey(urlSalome);
		}catch (Exception e) {
			MD5paswd.key = new SecretKeySpec(cle.getBytes() , "DES");
		}
		String mdpMantisCrypte =MD5paswd.encrypString(getImportMantisFTPPasswordTextbox());
		prep.setString(13, mdpMantisCrypte);
		if (getImportMantisFTPDirectoryTextbox().length()==0){
			setImportMantisFTPDirectoryTextbox("/");
		}
		if(!getImportMantisFTPDirectoryTextbox().startsWith("/")){
			setImportMantisFTPDirectoryTextbox("/" + getImportMantisFTPDirectoryTextbox());
		}
		if(!getImportMantisFTPDirectoryTextbox().endsWith("/")){
			setImportMantisFTPDirectoryTextbox(getImportMantisFTPDirectoryTextbox() + "/");
		}
		prep.setString(14, getImportMantisFTPDirectoryTextbox());
		SQLWrapper.runAddQuery(prep);
		
		} catch (Exception e) {
					SalomeTMFContext.getInstance().showMessage(
							Language.getInstance().getText("Erreur_acces_BDD"),
							Language.getInstance().getText("Probleme_config"),
							JOptionPane.WARNING_MESSAGE);
				//	FenetreSaisieConfig.this.dispose();
				} 
		}
		FenetreSaisieConfig.this.dispose();
	}

    /**
     * Selection de la variable exportSalomeDataBase
     * @return boolean
     */
	public boolean getExportSalomeDataBase() {
		return exportSalomeDataBase.isSelected();
	}

    /**
     * Selection de la variable exportSalomeFile
     * @return boolean
     */
	public boolean getExportSalomeFile() {
		return exportSalomeFile.isSelected();
	}
/**
     * Selection de la variable exportSalomeFTP
     * @return boolean
     */
	public boolean getExportSalomeFTP() {
		return exportSalomeFTP.isSelected();
	}
/**
     * Selection de la variable exportSalomeFTPDirectoryTextbox
     * @return String
     */
	public String getExportSalomeFTPDirectoryTextbox() {
		return exportSalomeFTPDirectoryTextbox.getText();
	}
/**
     * Selection de la variable exportSalomeFTPLoginTextbox
     * @return String
     */
	public String getExportSalomeFTPLoginTextbox() {
		return exportSalomeFTPLoginTextbox.getText();
	}
/**
     * Selection de la variable exportSalomeFTPPasswordTextbox
     * @return String
     */
	public String getExportSalomeFTPPasswordTextbox() {
		return exportSalomeFTPPasswordTextbox.getText();
	}
/**
     * Selection de la variable exportSalomeFTPServeurTextbox
     * @return String
     */
	public String getExportSalomeFTPServeurTextbox() {
		return exportSalomeFTPServeurTextbox.getText();
	}
/**
     * Selection de la variable exportSalomeRepertoireTextbox
     * @return String
     */
	public String getExportSalomeRepertoireTextbox() {
		String contenu = exportSalomeRepertoireTextbox.getText();
		contenu = contenu.replaceAll("\\\\", "/"); 
		return contenu;
	}
/**
     * Selection de la variable importMantisRepertoireTextbox
     * @return String
     */
	public String getImportMantisRepertoireTextbox() {
		String contenu = importMantisRepertoireTextbox.getText();
		contenu = contenu.replaceAll("\\\\", "/"); 
		return contenu;
	}
 /**
     * Selection de la variable sortieFTP_FTP
     * @return boolean
     */
	public boolean getSortieFTP_FTP() {
		return sortieFTP_FTP.isSelected();
	}
 /**
     * Selection de la variable sortieFTP_HTTP
     * @return boolean
     */
	public boolean getSortieFTP_HTTP() {
		return sortieFTP_HTTP.isSelected();
	}
 /**
     * Selection de la variable importMantisDataBase
     * @return boolean
     */
	public boolean getImportMantisDataBase() {
		return importMantisDataBase.isSelected();
	}
 /**
     * Selection de la variable importMantisFile
     * @return boolean
     */
	public boolean getImportMantisFile() {
		return importMantisFile.isSelected();
	}
/**
     * Selection de la variable importMantisFTP
     * @return boolean
     */
	public boolean getImportMantisFTP() {
		return importMantisFTP.isSelected();
	}
	/**
     * Selection de la variable importMantisFTPDirectoryTextbox
     * @return String
     */
	public String getImportMantisFTPDirectoryTextbox() {
		return importMantisFTPDirectoryTextbox.getText();
	}
/**
     * Selection de la variable importMantisFTPLoginTextbox
     * @return String
     */
	public String getImportMantisFTPLoginTextbox() {
		return importMantisFTPLoginTextbox.getText();
	}
/**
     * Selection de la variable importMantisFTPPasswordTextbox
     * @return String
     */
	public String getImportMantisFTPPasswordTextbox() {
		return importMantisFTPPasswordTextbox.getText();
	}
/**
     * Selection de la variable importMantisFTPServeurTextbox
     * @return String
     */
	public String getImportMantisFTPServeurTextbox() {
		return importMantisFTPServeurTextbox.getText();
	}
/**
     * Selection de la variable exportSalomeDataBase
     */	
	public void setExportSalomeDataBase() {
		 exportSalomeDataBase.setSelected(true);
	}
/**
     * Selection de la variable exportSalomeFile
     */	
	public void setExportSalomeFile() {
		 exportSalomeFile.setSelected(true);
	}
/**
     * Selection de la variable exportSalomeFTP
     */	
	public void setExportSalomeFTP() {
		 exportSalomeFTP.setSelected(true);
	}
/**
     * Selection de la variable exportSalomeFTPDirectoryTextbox
     * @param text Chaine de caractres
     */	
	public void setExportSalomeFTPDirectoryTextbox(String text) {
		 exportSalomeFTPDirectoryTextbox.setText(text);
	}
/**
     * Selection de la variable exportSalomeFTPLoginTextbox
     * @param text Chaine de caractres
     */	
	public void setExportSalomeFTPLoginTextbox(String text) {
		 exportSalomeFTPLoginTextbox.setText(text);
	}
/**
     * Selection de la variable exportSalomeFTPPasswordTextbox
     * @param text Chaine de caractres
     */	
	public void setExportSalomeFTPPasswordTextbox(String text) {
		 exportSalomeFTPPasswordTextbox.setText(text);
	}
/**
     * Selection de la variable exportSalomeFTPServeurTextbox
     * @param text Chaine de caractres
     */	
	public void setExportSalomeFTPServeurTextbox(String text) {
		 exportSalomeFTPServeurTextbox.setText(text);
	}
/**
     * Selection de la variable exportSalomeRepertoireTextbox
     * @param text Chaine de caractres
     */	
	public void setExportSalomeRepertoireTextbox(String text) {
		exportSalomeRepertoireTextbox.setText(text);
	}
/**
     * Selection de la variable importMantisRepertoireTextbox
     * @param text Chaine de caractres
     */	
	public void setImportMantisRepertoireTextbox(String text) {
		importMantisRepertoireTextbox.setText(text);
	}
/**
     * Selection de la variable sortieFTP_FTP
     */	
	public void setSortieFTP_FTP() {
		sortieFTP_FTP.setSelected(true);
	}
/**
     * Selection de la variable sortieFTP_HTTP
     */	
	public void setSortieFTP_HTTP() {
		sortieFTP_HTTP.setSelected(true);
	}
/**
     * Selection de la variable importMantisDataBase
     */	
	public void setImportMantisDataBase() {
		importMantisDataBase.setSelected(true);
	}
/**
     * Selection de la variable importMantisFile
     */	
	public void setImportMantisFile() {
		importMantisFile.setSelected(true);
	}
/**
     * Selection de la variable importMantisFTP
     */	
	public void setImportMantisFTP() {
		importMantisFTP.setSelected(true);
	}
/**
     * Selection de la variable importMantisFTPDirectoryTextbox
     * @param text Chaine de caractres
     */		
	public void setImportMantisFTPDirectoryTextbox(String text) {
		importMantisFTPDirectoryTextbox.setText(text);
	}
/**
     * Selection de la variable importMantisFTPLoginTextbox
     * @param text Chaine de caractres
     */	
	public void setImportMantisFTPLoginTextbox(String text) {
		importMantisFTPLoginTextbox.setText(text);
	}
/**
     * Selection de la variable importMantisFTPPasswordTextbox
     * @param text Chaine de caractres
     */	
	public void setImportMantisFTPPasswordTextbox(String text) {
		importMantisFTPPasswordTextbox.setText(text);
	}
/**
     * Selection de la variable importMantisFTPServeurTextbox
     * @param text Chaine de caractres
     */	
	public void setImportMantisFTPServeurTextbox(String text) {
		importMantisFTPServeurTextbox.setText(text);
	}

	
}  